/// <reference types="react" />
import * as React from 'react';
/**
 * Small button with an icon instead of text.
 */
declare module ActionButton {
    interface Props extends React.Props<ActionButton> {
        /** onClick method. */
        clickAction?: React.EventHandler<React.MouseEvent<Element>>;
        /** Any FontAwesome icon CSS class names like "fa-info" or "fa-info fa-lg". */
        iconClass?: string;
        /** Set the icon color class. Do not use if you don't need it, otherwise btnClass will have trouble handeling hover color. */
        colorClass?: string;
        /** Disabling button if true. */
        disabled?: boolean;
        /** A text that will be displayed in the "title" HTML attribute of the button. */
        tooltipText?: string;
        /**
         * Any available Portal CSS class names you want to apply to the icon wrapper <strong>div</strong>.
         * This can be used to space the icon from any other content.
         */
        btnClass?: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<ActionButton>;
    }
}
declare class ActionButton extends React.Component<ActionButton.Props, any> {
    constructor(props: ActionButton.Props);
    render(): JSX.Element;
}
export default ActionButton;
