/// <reference types="react" />
/**
 * Created by franckmontaigne on 28/03/17.
 */
import * as React from 'react';
/**
 * Component allowing you to display a set of buttons as well as a search input if needed.
 */
declare module ButtonsBar {
    interface BtnGroupsProps {
        btns: ButtonProps[];
        style?: React.CSSProperties;
        cssClass?: string;
    }
    interface ButtonProps {
        clickAction?: () => void;
        cssClass?: string;
        iconClass?: string;
        text?: string;
        disabled?: boolean;
        tooltipText?: string;
        btnContent?: JSX.Element;
        content?: JSX.Element;
        type?: string;
    }
    interface Props extends React.Props<ButtonsBar> {
        /** Handle search value. */
        handleSearch?: (searchValue: string) => void;
        /** Search value usually used with list beneath it. */
        searchValue?: string;
        /** Button list to be displayed. More details on [BtnGroupsProps](https:localhost:6060/#btngroupsprops) */
        btnGroups: BtnGroupsProps[];
        /** Locale to be used. */
        locale: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<ButtonsBar>;
    }
    interface State {
        searchValue?: string;
        wordings?: {
            [id: string]: string;
        };
    }
}
declare class ButtonsBar extends React.Component<ButtonsBar.Props, ButtonsBar.State> {
    constructor(props: ButtonsBar.Props);
    componentDidUpdate(prevProps: ButtonsBar.Props): void;
    render(): JSX.Element;
    private handleSearch;
}
export default ButtonsBar;
