"use strict";
/**
 * Created by franckmontaigne on 28/03/17.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Wordings
var wordings_1 = require("@amalto/wordings");
// Utils
var helpers_1 = require("@amalto/helpers");
var ButtonsBar = /** @class */ (function (_super) {
    __extends(ButtonsBar, _super);
    function ButtonsBar(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSearch = function (event) {
            event.preventDefault();
            _this.props.handleSearch(_this.state.searchValue);
        };
        _this.state = {
            searchValue: props.handleSearch && props.searchValue || '',
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    ButtonsBar.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.searchValue !== this.props.searchValue && this.props.handleSearch) {
            this.setState({ searchValue: this.props.searchValue });
        }
    };
    ButtonsBar.prototype.render = function () {
        var _this = this;
        var _a = this.props, handleSearch = _a.handleSearch, btnGroups = _a.btnGroups;
        var _b = this.state, searchValue = _b.searchValue, wordings = _b.wordings;
        return btnGroups && btnGroups.length || handleSearch ? (React.createElement("div", { className: "btn-toolbar" },
            btnGroups.map(function (btnGroup, idx) {
                return (React.createElement("div", { key: idx, className: classNames("btn-group btn-group-sm", (_a = {},
                        _a[btnGroup.cssClass] = !!btnGroup.cssClass,
                        _a)), style: btnGroup.style }, btnGroup.btns && btnGroup.btns.length ? (btnGroup.btns.map(function (btn, idx) {
                    var Button = !btn.btnContent ? (React.createElement("button", { key: idx, onClick: btn.clickAction, className: classNames('btn', btn.cssClass), disabled: btn.disabled, "data-original-title": btn.tooltipText, type: btn.type || 'button', "data-toggle": "tooltip" }, btn.content ? btn.content : btn.text ? (React.createElement("span", null,
                        btn.iconClass ? React.createElement("span", { className: classNames('fa-fw right-spaced', btn.iconClass) }) : null,
                        React.createElement("span", null, btn.text))) : React.createElement("span", { className: classNames('fa-fw', btn.iconClass) }))) : (React.createElement("div", { key: idx, onClick: btn.clickAction, className: classNames('btn', btn.cssClass, {
                            'disabled': btn.disabled
                        }), "data-original-title": btn.tooltipText, "data-toggle": "tooltip" }, btn.btnContent));
                    return Button;
                })) : null));
                var _a;
            }),
            handleSearch ? (React.createElement("div", { className: "btn-group btn-group-sm icon-input pull-right" },
                React.createElement("form", { onSubmit: this.handleSearch },
                    React.createElement("input", { type: "text", className: "form-control", value: searchValue, onChange: function (e) { _this.setState({ searchValue: e.target.value }); }, placeholder: wordings['searchPlaceholder'] })),
                React.createElement("div", { className: "icon-ctn" },
                    React.createElement("span", { className: "fa fa-fw fa-search text-medium default-color" }),
                    React.createElement("span", { className: "v-align-hook" })))) : null)) : null;
    };
    return ButtonsBar;
}(React.Component));
exports.default = ButtonsBar;
//# sourceMappingURL=index.js.map