"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var redux_form_1 = require("redux-form");
var classNames = require("classnames");
// Helpers
var helpers_1 = require("@amalto/helpers");
// Components
var help_1 = require("@amalto/help");
var Checkboxes = /** @class */ (function (_super) {
    __extends(Checkboxes, _super);
    function Checkboxes(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var input = _this.props.input;
            var selectedValues = input.value ? input.value.filter(function (item) { return !!item; }) : [];
            if (event.target.checked) {
                input.onChange(helpers_1.addValToArrayNoDup(selectedValues, event.target.value), undefined, undefined);
            }
            else {
                input.onChange(helpers_1.removeValFromArrayNoDup(selectedValues, event.target.value), undefined, undefined);
            }
        };
        return _this;
    }
    Checkboxes.prototype.render = function () {
        var _this = this;
        var _a = this.props, label = _a.label, disabled = _a.disabled, help = _a.help, containerClass = _a.containerClass, inputClass = _a.inputClass, collapseErrorSpace = _a.collapseErrorSpace, options = _a.options, input = _a.input, meta = _a.meta;
        return (React.createElement("div", { className: classNames('form-group', containerClass, {
                'invalid': meta.touched && !!meta.error
            }) },
            label ? React.createElement("label", null,
                label,
                help && React.createElement(help_1.default, { text: help })) : null,
            React.createElement("div", { className: classNames('fieldset', {
                    'invalid': meta.touched && !!meta.error
                }) }, options.filter(function (opt) { return !!opt.value; }).map(function (opt, idx) { return (React.createElement("span", { className: classNames('form-checkbox-wrapper', inputClass), key: idx },
                React.createElement("input", { type: "checkbox", className: "form-checkbox", disabled: disabled, id: input.name + '_' + idx, value: opt.value, onChange: function (e) { return _this.handleChange(e); }, checked: input.value.indexOf(opt.value) !== -1 }),
                React.createElement("label", { className: "form-checkbox-label", htmlFor: input.name + '_' + idx }, opt.label || opt.value))); })),
            (meta.touched && !!meta.error) ? React.createElement("p", { className: "validation-error-message" }, meta.error) : (collapseErrorSpace ? null : React.createElement("p", { className: "validation-error-message" }, "\u00A0")),
            React.createElement("input", __assign({ type: "hidden" }, input))));
    };
    return Checkboxes;
}(React.Component));
var CheckboxesInput = /** @class */ (function (_super) {
    __extends(CheckboxesInput, _super);
    function CheckboxesInput(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    CheckboxesInput.prototype.render = function () {
        var _a = this.props, name = _a.name, label = _a.label, options = _a.options, disabled = _a.disabled, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn
        };
        var props = JSON.parse(JSON.stringify(this.props));
        return options && options.length ? (React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, props, { component: Checkboxes }))) : null;
    };
    return CheckboxesInput;
}(React.Component));
exports.default = CheckboxesInput;
//# sourceMappingURL=index.js.map