/// <reference types="react" />
import * as React from 'react';
/**
 * Choose a color from a panel
 */
declare module ColorPicker {
    interface Props extends React.Props<ColorPicker> {
        /** Current hexadecimal string color. */
        color: string;
        /** Callback function executed when the user selects a color. */
        handleColorChange: (color: string) => void;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<ColorPicker>;
    }
}
/**
 * Allow you to choose a color within a list.
 */
declare class ColorPicker extends React.Component<ColorPicker.Props, any> {
    constructor(props: ColorPicker.Props);
    render(): JSX.Element;
    private handleColorClick;
    private colors;
}
export default ColorPicker;
