"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
/**
 * Allow you to choose a color within a list.
 */
var ColorPicker = /** @class */ (function (_super) {
    __extends(ColorPicker, _super);
    function ColorPicker(props) {
        var _this = _super.call(this, props) || this;
        _this.handleColorClick = function (event) {
            _this.props.handleColorChange(event.currentTarget.getAttribute('data-color-hex'));
        };
        _this.colors = function () {
            return [
                "#ffffff", "#000000", "#b4dcfa", "#5eccf3", "#a7ea52", "#5dceaf", "#ff8021", "#f14124",
                "#f0f3f3", "#7e7e7e", "#8bc9f7", "#def4fc", "#edfadc", "#def5ef", "#ffe5d2", "#fcd9d3",
                "#d8d8d8", "#565656", "#4facf3", "#beeafa", "#dbf6b9", "#beebdf", "#ffcca6", "#f9b3a7",
                "#bfbfbf", "#3a3a3a", "#0d78c9", "#9ee0f7", "#caf297", "#9de1cf", "#ffb279", "#f68d7b",
                "#a5a5a5", "#262626", "#063c64", "#11b2eb", "#81d319", "#34ac8b", "#d85c00", "#c3260c",
                "#7f7f7f", "#0c0c0c", "#021828", "#0b769c", "#568c11", "#22725c", "#903d00", "#821908"
            ];
        };
        return _this;
    }
    ColorPicker.prototype.render = function () {
        var _this = this;
        var palette = this.colors().map(function (colorCode, idx) {
            var styles = {
                backgroundColor: colorCode
            };
            return (React.createElement("div", { key: idx, style: styles, className: classNames('color-selector', {
                    'selected': _this.props.color === colorCode
                }), onClick: _this.handleColorClick, "data-color-hex": colorCode }));
        });
        return (React.createElement("div", { className: "custom-color-picker" },
            React.createElement("div", { className: "custom-color-palette" }, palette)));
    };
    return ColorPicker;
}(React.Component));
exports.default = ColorPicker;
//# sourceMappingURL=index.js.map