"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Wordings
var wordings_1 = require("@amalto/wordings");
// Utils
var helpers_1 = require("@amalto/helpers");
// Components
var switch_1 = require("@amalto/switch");
var validated_input_1 = require("@amalto/validated-input");
// Constants
exports.CRON_VALIDATION = {
    SECOND: /[^0-9\,\-\*\/]/,
    MINUTE: /[^0-9\,\-\*\/]/,
    HOUR: /[^0-9\,\-\*\/]/,
    DAY_OF_MONTH: /[^0-9WL\,\-\*\/\?]/,
    MONTH: /[^0-9\,\-\*\/JANFEBMRPRYJUNLGOCTVD]/,
    DAY_OF_WEEK: /[^1-7\,\-\*\/\?#SUNMOTEWDHFRIAL]/,
    YEAR: /[^\,\-\*\/0-9]/
};
var CronInput = /** @class */ (function (_super) {
    __extends(CronInput, _super);
    function CronInput(props) {
        var _this = _super.call(this, props) || this;
        _this.handleFieldChange = function (fieldValue, fieldName, isInvalid) {
            _this.setState((_a = {},
                _a[fieldName] = fieldValue,
                _a), function () {
                _this.props.handleChange(_this.getCronValue());
            });
            var _a;
        };
        _this.getCronValue = function () {
            var stateCopy = JSON.parse(JSON.stringify(_this.state));
            return {
                enabled: stateCopy.enabled,
                second: stateCopy.second,
                minute: stateCopy.minute,
                hour: stateCopy.hour,
                dayOfMonth: stateCopy.dayOfMonth,
                month: stateCopy.month,
                dayOfWeek: stateCopy.dayOfWeek,
                year: stateCopy.year
            };
        };
        _this.state = {
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        $.extend(_this.state, props.value);
        return _this;
    }
    CronInput.prototype.render = function () {
        var _this = this;
        var _a = this.props, name = _a.name, invalid = _a.invalid, containerClass = _a.containerClass, forceValidation = _a.forceValidation;
        var _b = this.state, wordings = _b.wordings, enabled = _b.enabled, second = _b.second, minute = _b.minute, hour = _b.hour, dayOfMonth = _b.dayOfMonth, month = _b.month, dayOfWeek = _b.dayOfWeek, year = _b.year;
        return (React.createElement("div", { className: classNames('fieldset', containerClass) },
            this.props.label ? React.createElement("label", null, this.props.label) : null,
            React.createElement("div", { className: "cron-input-wrapper clearfix" },
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.second'], name: "second", value: second, handleFieldChange: this.handleFieldChange, help: "0-59 / * - ,", validate: function (value) { return !exports.CRON_VALIDATION.SECOND.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.minute'], name: "minute", value: minute, handleFieldChange: this.handleFieldChange, help: "0-59 / * - ,", validate: function (value) { return !exports.CRON_VALIDATION.MINUTE.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.hour'], name: "hour", value: hour, handleFieldChange: this.handleFieldChange, help: "0-23 / * - ,", validate: function (value) { return !exports.CRON_VALIDATION.HOUR.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.day.of.month'], name: "dayOfMonth", value: dayOfMonth, handleFieldChange: this.handleFieldChange, help: "1-31 W L / ? * - ,", validate: function (value) { return !exports.CRON_VALIDATION.DAY_OF_MONTH.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.month'], name: "month", value: month, handleFieldChange: this.handleFieldChange, help: "1-12 JAN-DEC / * - ,", validate: function (value) { return !exports.CRON_VALIDATION.MONTH.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.day.of.week'], name: "dayOfWeek", value: dayOfWeek, handleFieldChange: this.handleFieldChange, help: "1-7 SUN-SAT # L / ? * - ,", validate: function (value) { return !exports.CRON_VALIDATION.DAY_OF_WEEK.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element" },
                    React.createElement(validated_input_1.default, { label: wordings['croninput.year'], name: "year", value: year, handleFieldChange: this.handleFieldChange, help: "empty 1970-2099 / * - ,", validate: function (value) { return !exports.CRON_VALIDATION.YEAR.test(value); }, formSubmitted: forceValidation, disabled: !enabled })),
                React.createElement("div", { className: "cron-input-element text-center" },
                    React.createElement("label", null, wordings['croninput.enabled']),
                    React.createElement(switch_1.default, { id: "cron_enabled_control_" + name, value: enabled, changeHandler: function (value) { _this.setState({ enabled: value }, function () { _this.props.handleChange(_this.getCronValue()); }); } }))),
            invalid && React.createElement("p", { className: "validation-error-message" }, wordings['croninput.invalid'])));
    };
    return CronInput;
}(React.Component));
exports.default = CronInput;
//# sourceMappingURL=index.js.map