/// <reference types="react" />
import * as React from 'react';
import { WorkflowActionParam } from '../models/Workflow';
import FileWrapper from '../models/FileWrapper';
declare module FormInput {
    interface Props extends React.Props<FormInput> {
        inputDef: WorkflowActionParam;
        inputValue: any;
        invalid: boolean;
        handleChange: (inputName: string, value: string | boolean) => void;
        fileUploadSessionToken: string;
        newFileUploadSession: () => void;
        cancelFileUploadSession: () => void;
        filesQueue: {
            [fileName: string]: FileWrapper;
        };
        addFiles: (files: File[]) => void;
        deleteFile: (fileName: string) => void;
        locale: string;
    }
    interface State {
        wordings?: {
            [id: string]: string;
        };
    }
}
declare class FormInput extends React.Component<FormInput.Props, FormInput.State> {
    constructor(props: FormInput.Props);
    render(): JSX.Element;
    componentWillReceiveProps(nextProps: FormInput.Props): void;
    private handleValueChange;
    private handleInput;
}
export default FormInput;
