"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
var switch_1 = require("@amalto/switch");
var file_input_1 = require("@amalto/file-input");
var FormInput = /** @class */ (function (_super) {
    __extends(FormInput, _super);
    function FormInput(props) {
        var _this = _super.call(this, props) || this;
        _this.handleValueChange = function (value) {
            if (_this.props.inputDef.name) {
                _this.props.handleChange(_this.props.inputDef.name, value);
            }
        };
        _this.handleInput = function (event) {
            if (_this.props.inputDef.name) {
                if (event.target.type === 'checkbox') {
                    var updatedValues = _this.props.inputValue ? _this.props.inputValue.split(',') : [];
                    //remove empty values
                    updatedValues = updatedValues.filter(function (value) {
                        return !!value;
                    });
                    if (event.target.checked) {
                        updatedValues.push(event.target.value);
                    }
                    else {
                        updatedValues.splice(updatedValues.indexOf(event.target.value), 1);
                    }
                    _this.props.handleChange(_this.props.inputDef.name, updatedValues.join(','));
                }
                else {
                    _this.props.handleChange(_this.props.inputDef.name, event.target.value);
                }
            }
        };
        _this.state = {
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    FormInput.prototype.render = function () {
        var _this = this;
        var wordings = this.state.wordings;
        var _a = this.props, inputDef = _a.inputDef, locale = _a.locale;
        var language = locale.substr(0, 2).toUpperCase();
        var label = inputDef.i18nLabelMap ? inputDef.i18nLabelMap[language] : null;
        var input = null;
        var baseInputProps = {
            className: 'form-control',
            value: this.props.inputValue
        };
        switch (inputDef.inputType) {
            case 'TEXTAREA':
                {
                    input = React.createElement("textarea", __assign({}, baseInputProps, { onChange: this.handleInput }));
                    break;
                }
            case 'SELECT':
                {
                    input = (React.createElement("select", __assign({}, baseInputProps, { onChange: this.handleInput }),
                        React.createElement("option", { value: "" }, wordings['forminput.select.value']),
                        inputDef.choices.map(function (choice, idx) {
                            var choiceLabel = choice.i18nLabelMap ? choice.i18nLabelMap[language] : choice.value;
                            return React.createElement("option", { key: choice.value + idx, value: choice.value }, choiceLabel);
                        })));
                    break;
                }
            case 'CHECKBOX':
                {
                    input = (React.createElement("div", null, inputDef.choices.map(function (choice, idx) {
                        var choiceLabel = choice.i18nLabelMap ? choice.i18nLabelMap[language] : choice.value;
                        var isChecked = _this.props.inputValue ? _this.props.inputValue.split(',').indexOf(choice.value) !== -1 : false;
                        return (React.createElement("span", { className: "form-checkbox-wrapper right-margin", key: idx },
                            React.createElement("input", { className: "form-checkbox", type: "checkbox", id: choice.value, name: choice.value, value: choice.value, checked: isChecked, onChange: _this.handleInput }),
                            React.createElement("label", { className: "form-checkbox-label", htmlFor: choice.value }, choiceLabel)));
                    })));
                    break;
                }
            case 'SWITCH':
                {
                    input = React.createElement(switch_1.default, { id: inputDef.name, value: this.props.inputValue, changeHandler: this.handleValueChange, alignLeft: true });
                    break;
                }
            case 'FILES':
                {
                    input = this.props.fileUploadSessionToken ? (React.createElement(file_input_1.default, { cancelSubmit: this.props.cancelFileUploadSession, filesQueue: this.props.filesQueue, addFilesToQueue: this.props.addFiles, deleteUploadedFile: this.props.deleteFile, locale: locale })) : (React.createElement("div", null,
                        React.createElement("button", { className: "btn btn-sm btn-font btn-trans", onClick: this.props.newFileUploadSession }, wordings['forminput.add.files'])));
                    break;
                }
            case 'TEXT':
            default:
                {
                    input = React.createElement("input", __assign({ type: "text" }, baseInputProps, { onChange: this.handleInput }));
                    break;
                }
        }
        var labelDisplay = label ? React.createElement("label", null, label) : null;
        return (React.createElement("div", { className: "col-xs-12" },
            React.createElement("div", { className: classNames('form-group bottom-margin', {
                    'mandatory': this.props.inputDef.mandatory,
                    'invalid': this.props.invalid
                }) },
                labelDisplay,
                input)));
    };
    FormInput.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.inputDef.inputType === 'FILES' && this.props.fileUploadSessionToken !== nextProps.fileUploadSessionToken) {
            var token = nextProps.fileUploadSessionToken ? nextProps.fileUploadSessionToken : '';
            this.props.handleChange(this.props.inputDef.name, token);
        }
    };
    return FormInput;
}(React.Component));
exports.default = FormInput;
//# sourceMappingURL=FormInput.js.map