"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
var spinner_1 = require("@amalto/spinner");
var toggle_panel_1 = require("@amalto/toggle-panel");
var CustomFormDialog = /** @class */ (function (_super) {
    __extends(CustomFormDialog, _super);
    function CustomFormDialog(props) {
        var _this = _super.call(this, props) || this;
        _this.refreshData = function () {
            _this.setState({
                preventRedraw: true
            }, function () {
                _this.props.refreshData();
            });
        };
        _this.getFormDisplay = function () {
            var formData = _this.props.formData;
            var wordings = _this.state.wordings;
            var dialogContent = React.createElement("div", null);
            if (formData.fetching) {
                dialogContent = React.createElement(spinner_1.default, null);
            }
            else if (formData.content) {
                var customComponent = eval(_this.props.formData.content);
                if (customComponent) {
                    _this.setState({
                        customComponent: customComponent.default || customComponent
                    });
                    return (React.createElement(spinner_1.default, null));
                }
                else {
                    dialogContent = (React.createElement("div", { className: "text-medium danger-color", style: { lineHeight: '22px' } },
                        React.createElement("span", { className: "fas fa-exclamation-triangle right-spaced" }),
                        React.createElement("span", null, wordings['customformdialog.error.loading'])));
                }
            }
            else if (formData.loadingError) {
                dialogContent = (React.createElement("div", { className: "text-medium danger-color", style: { lineHeight: '22px' } },
                    React.createElement("span", { className: "fas fa-exclamation-triangle right-spaced" }),
                    React.createElement("span", null, wordings['customformdialog.error.loading'])));
            }
            return (React.createElement(toggle_panel_1.default, { panelTitle: _this.props.title, defaultOpened: true, togglable: false, cancelBtn: {
                    label: wordings['customformdialog.cancel'],
                    action: _this.props.closeForm
                } },
                React.createElement("div", { className: "col-xs-12" }, dialogContent)));
        };
        _this.submitForm = function (payload) {
            _this.props.closeForm();
            _this.props.confirmAction(payload);
        };
        _this.state = {
            customComponent: null,
            display: null,
            preventRedraw: false,
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    CustomFormDialog.prototype.render = function () {
        var _a = this.props, api = _a.api, title = _a.title, closeForm = _a.closeForm, formData = _a.formData, fileUploadSessionToken = _a.fileUploadSessionToken, newFileUploadSession = _a.newFileUploadSession, cancelFileUploadSession = _a.cancelFileUploadSession, filesQueue = _a.filesQueue, addFiles = _a.addFiles, deleteFile = _a.deleteFile, showDialog = _a.showDialog, hideDialog = _a.hideDialog, displayNotification = _a.displayNotification, handleErrorDisplay = _a.handleErrorDisplay, appHistory = _a.appHistory;
        var componentProps = {
            title: title,
            closeForm: closeForm,
            submitForm: this.submitForm,
            initialValues: formData.model,
            data: formData.model,
            fileUploadSessionToken: fileUploadSessionToken,
            newFileUploadSession: newFileUploadSession,
            cancelFileUploadSession: cancelFileUploadSession,
            filesQueue: filesQueue,
            addFiles: addFiles,
            deleteFile: deleteFile,
            api: api,
            appHistory: appHistory,
            refreshData: this.refreshData,
            showDialog: showDialog,
            hideDialog: hideDialog,
            displayNotification: displayNotification,
            handleErrorDisplay: handleErrorDisplay
        };
        return (React.createElement("div", { className: "form-dialog" },
            React.createElement("div", { className: "col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2" }, this.state.customComponent ? (React.createElement(this.state.customComponent, __assign({}, componentProps))) : this.state.display)));
    };
    CustomFormDialog.prototype.componentDidMount = function () {
        this.setState({
            display: this.getFormDisplay()
        });
    };
    CustomFormDialog.prototype.componentDidUpdate = function (prevProps, prevState) {
        if ((this.state.preventRedraw !== true) && prevProps.formData !== this.props.formData) {
            this.setState({
                display: this.getFormDisplay()
            });
        }
    };
    return CustomFormDialog;
}(React.Component));
exports.default = CustomFormDialog;
//# sourceMappingURL=index.js.map