/// <reference types="react" />
/**
 * Created by franckmontaigne on 02/06/16.
 */
import * as React from 'react';
import NotificationModel from '../models/NotificationModel';
import { ColumnHeader } from '../models/DataGrid';
import { DisplayTemplate } from '../models/DisplayTemplate';
declare module HeaderItem {
    interface Props extends React.Props<HeaderItem> {
        columnHeader: ColumnHeader;
        sortHandler?: (columnId: string, sortDirection: string) => void;
        sortColumn?: string;
        sortDirection?: string;
        preventTemplating?: boolean;
        orderHandler?: (columnId: string, order: string) => void;
        widthHandler?: (columnId: string, way: string) => void;
        textAlignHandler?: (columnId: string, align: string) => void;
        displayHandler?: (columnId: string, display: boolean) => void;
        templateChangeHandler?: (template: DisplayTemplate) => void;
        displayContextMenu?: (content: any, positionX?: number, positionY?: number) => void;
        displayNotification?: (notificationOptions?: NotificationModel) => void;
        hideContextMenu?: () => void;
        displayTemplate?: DisplayTemplate;
        locale: string;
    }
    interface State {
        wordings?: {
            [id: string]: string;
        };
    }
}
declare class HeaderItem extends React.Component<HeaderItem.Props, HeaderItem.State> {
    constructor(props: HeaderItem.Props);
    render(): JSX.Element;
    private handleCardContextMenu;
    private updateContextMenu;
    private handleColorChange;
    private closeContextMenu;
    private handleMenuEnter;
    private handleMenuLeave;
    private handleOrderChange;
    private hideColumn;
    private handleSortChange;
    private handleWidthChange;
    private handleTextAlignChange;
}
export default HeaderItem;
