"use strict";
/**
 * Created by franckmontaigne on 02/06/16.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Components
var HeaderItem_1 = require("./HeaderItem");
var HeaderLine = /** @class */ (function (_super) {
    __extends(HeaderLine, _super);
    function HeaderLine(props) {
        return _super.call(this, props) || this;
    }
    HeaderLine.prototype.render = function () {
        var _this = this;
        var _a = this.props, displayTemplate = _a.displayTemplate, columnHeaders = _a.columnHeaders, stickyHeader = _a.stickyHeader, locale = _a.locale;
        var filteredAndSortedColumnHeaders = columnHeaders;
        if (displayTemplate) {
            filteredAndSortedColumnHeaders = columnHeaders.filter(function (columnHeader) {
                //FIXME
                /* hardcoded access to desktop display mode */
                if (displayTemplate[columnHeader.id]) {
                    return displayTemplate[columnHeader.id].desktop.display !== false;
                }
                return true;
            }).sort(function (colA, colB) {
                if (displayTemplate[colA.id] && displayTemplate[colA.id].desktop && displayTemplate[colB.id] && displayTemplate[colB.id].desktop) {
                    return displayTemplate[colA.id].desktop.order - displayTemplate[colB.id].desktop.order;
                }
                return 0;
            });
        }
        var columnHeadersDisplay = filteredAndSortedColumnHeaders.map(function (columnHeader, idx) {
            return (React.createElement(HeaderItem_1.default, { key: columnHeader.id, columnHeader: columnHeader, sortHandler: _this.props.sortHandler, sortColumn: _this.props.sortColumn, sortDirection: _this.props.sortDirection, preventTemplating: _this.props.preventTemplating, orderHandler: _this.props.orderHandler, displayHandler: _this.props.displayHandler, widthHandler: _this.props.widthHandler, textAlignHandler: _this.props.textAlignHandler, templateChangeHandler: _this.props.templateChangeHandler, displayContextMenu: _this.props.displayContextMenu, displayNotification: _this.props.displayNotification, hideContextMenu: _this.props.hideContextMenu, displayTemplate: displayTemplate, locale: locale }));
        });
        return (React.createElement("div", { className: classNames({
                'sticky-dg-header': stickyHeader
            }) },
            React.createElement("div", { className: classNames('dg-inline-headers', {
                    'mgb-10': !stickyHeader
                }) }, columnHeadersDisplay)));
    };
    return HeaderLine;
}(React.Component));
exports.default = HeaderLine;
//# sourceMappingURL=HeaderLine.js.map