"use strict";
/**
 * Created by franckmontaigne on 13/06/16.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var react_redux_1 = require("react-redux");
var classNames = require("classnames");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
var spinner_1 = require("@amalto/spinner");
var SelectablesContainer_1 = require("./components/SelectablesContainer");
var buttons_bar_1 = require("@amalto/buttons-bar");
var HeaderLine_1 = require("./components/HeaderLine");
var UserModel_1 = require("./models/UserModel");
var DataGrid = /** @class */ (function (_super) {
    __extends(DataGrid, _super);
    function DataGrid(props) {
        var _this = _super.call(this, props) || this;
        _this.getTemplateInjectedDataLines = function () {
            return _this.props.dataLines.map(function (dataLine) { return React.cloneElement(dataLine, { displayTemplate: _this.getDisplayTemplate() }); });
        };
        _this.getDisplayTemplate = function () {
            var _a = _this.props, selectedAppInstanceName = _a.selectedAppInstanceName, dataGridId = _a.dataGridId, forcedServiceId = _a.forcedServiceId, defaultServiceId = _a.defaultServiceId, templates = _a.templates;
            var _serviceId = forcedServiceId || defaultServiceId;
            if (_serviceId && dataGridId && selectedAppInstanceName) {
                if (templates[selectedAppInstanceName] && templates[selectedAppInstanceName][_serviceId]) {
                    return templates[selectedAppInstanceName][_serviceId][dataGridId] || null;
                }
            }
            return null;
        };
        _this.bootstrapTemplate = function () {
            var _a = _this.props, dataGridActions = _a.dataGridActions, columnHeaders = _a.columnHeaders, dataGridId = _a.dataGridId, defaultServiceId = _a.defaultServiceId, forcedServiceId = _a.forcedServiceId, selectedAppInstanceName = _a.selectedAppInstanceName;
            var _serviceId = forcedServiceId || defaultServiceId;
            if (dataGridId && columnHeaders && _serviceId && selectedAppInstanceName) {
                var template = _this.getDisplayTemplate();
                if (!template) {
                    dataGridActions.bootstrapDataGridTemplate(columnHeaders, dataGridId, _serviceId, selectedAppInstanceName);
                }
                else {
                    dataGridActions.synchroniseDataGridTemplate(columnHeaders, dataGridId, _serviceId, selectedAppInstanceName);
                }
            }
        };
        _this.changeColumnOrder = function (columnId, order) {
            var _a = _this.props, dataGridActions = _a.dataGridActions, selectedAppInstanceName = _a.selectedAppInstanceName, dataGridId = _a.dataGridId, forcedServiceId = _a.forcedServiceId, defaultServiceId = _a.defaultServiceId;
            var _serviceId = forcedServiceId || defaultServiceId;
            //FIXME
            /* hardcoded access to desktop display mode */
            dataGridActions.changeColumnOrder(columnId, order, 'desktop', dataGridId, _serviceId, selectedAppInstanceName);
        };
        _this.changeColumnWidth = function (columnId, way) {
            var _a = _this.props, dataGridActions = _a.dataGridActions, selectedAppInstanceName = _a.selectedAppInstanceName, dataGridId = _a.dataGridId, forcedServiceId = _a.forcedServiceId, defaultServiceId = _a.defaultServiceId;
            var _serviceId = forcedServiceId || defaultServiceId;
            //FIXME
            /* hardcoded access to desktop display mode */
            dataGridActions.changeColumnWidth(columnId, way, 'desktop', dataGridId, _serviceId, selectedAppInstanceName);
        };
        _this.changeColumnTextAlign = function (columnId, align) {
            var _a = _this.props, dataGridActions = _a.dataGridActions, selectedAppInstanceName = _a.selectedAppInstanceName, dataGridId = _a.dataGridId, forcedServiceId = _a.forcedServiceId, defaultServiceId = _a.defaultServiceId;
            var _serviceId = forcedServiceId || defaultServiceId;
            //FIXME
            /* hardcoded access to desktop display mode */
            dataGridActions.changeColumnTextAlign(columnId, align, 'desktop', dataGridId, _serviceId, selectedAppInstanceName);
        };
        _this.changeColumnDisplay = function (columnId, display) {
            var _a = _this.props, dataGridActions = _a.dataGridActions, selectedAppInstanceName = _a.selectedAppInstanceName, dataGridId = _a.dataGridId, forcedServiceId = _a.forcedServiceId, defaultServiceId = _a.defaultServiceId;
            var _serviceId = forcedServiceId || defaultServiceId;
            //FIXME
            /* hardcoded access to desktop display mode */
            dataGridActions.changeColumnDisplay(columnId, display, 'desktop', dataGridId, _serviceId, selectedAppInstanceName);
            if (display === false) {
                _this.setState({
                    displayHiddenColumnsPanel: true
                });
            }
        };
        _this.resetTemplate = function () {
            var _a = _this.props, dataGridActions = _a.dataGridActions, columnHeaders = _a.columnHeaders, dataGridId = _a.dataGridId, defaultServiceId = _a.defaultServiceId, forcedServiceId = _a.forcedServiceId, selectedAppInstanceName = _a.selectedAppInstanceName;
            var _serviceId = forcedServiceId || defaultServiceId;
            if (dataGridId && columnHeaders && _serviceId && selectedAppInstanceName) {
                _this.props.showDialog(_this.state.wordings['datagrid.modal.confirm'], _this.state.wordings['datagrid.reset.confirm'], function () { return dataGridActions.bootstrapDataGridTemplate(columnHeaders, dataGridId, _serviceId, selectedAppInstanceName); }, _this.props.hideDialog());
            }
        };
        _this.changeTemplate = function (template) {
            var _a = _this.props, dataGridActions = _a.dataGridActions, selectedAppInstanceName = _a.selectedAppInstanceName, dataGridId = _a.dataGridId, forcedServiceId = _a.forcedServiceId, defaultServiceId = _a.defaultServiceId;
            var _serviceId = forcedServiceId || defaultServiceId;
            dataGridActions.changeDisplayTemplate(template, dataGridId, _serviceId, selectedAppInstanceName);
        };
        _this.getHiddenColumnsPanel = function () {
            var columnHeaders = _this.props.columnHeaders;
            var displayTemplate = _this.getDisplayTemplate();
            if (displayTemplate) {
                var hiddenColumns = columnHeaders.filter(function (columnHeader) {
                    //FIXME
                    /* hardcoded access to desktop display mode */
                    if (displayTemplate[columnHeader.id]) {
                        return displayTemplate[columnHeader.id].desktop.display === false;
                    }
                    return true;
                });
                if (hiddenColumns.length) {
                    return (React.createElement("div", { className: 'bordered padded mgt-10', style: { marginBottom: 22 } },
                        React.createElement("div", { className: 'mgb-5', style: { position: 'relative' } },
                            React.createElement("label", null, _this.state.wordings['datagrid.hidden.columns']),
                            React.createElement("span", { className: 'close-button small', onClick: function () { return _this.setState({ displayHiddenColumnsPanel: false }); } })),
                        React.createElement("div", null, hiddenColumns.map(function (columnHeader, idx) {
                            return (React.createElement("span", { key: columnHeader.id, className: 'tile inline-block padded-small text-xsmall mgr-10 click-pointer bold', onClick: function () { return _this.changeColumnDisplay(columnHeader.id.toString(), true); } }, columnHeader.label));
                        }))));
                }
            }
            return null;
        };
        _this.displayContextMenu = function (content, positionX, positionY) {
            _this.props.displayContextMenu(content, positionX, positionY);
        };
        _this.hideContextMenu = function () {
            _this.props.hideContextMenu();
        };
        _this.saveDataGridTemplate = function () {
            var _a = _this.props, api = _a.api, user = _a.user, templates = _a.templates, dataGridActions = _a.dataGridActions, saveDataGridTemplate = _a.saveDataGridTemplate;
            var userJson = UserModel_1.getUserJson(user);
            userJson.dataGridTemplates = templates;
            var payload = {
                userEmail: user.userEmail,
                jsonContent: JSON.stringify(userJson)
            };
            //update user data
            saveDataGridTemplate(payload);
        };
        _this.state = {
            displayHiddenColumnsPanel: false,
            templateDialogOpened: false,
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    DataGrid.prototype.componentWillMount = function () {
        this.bootstrapTemplate();
    };
    DataGrid.prototype.componentDidMount = function () {
        var _a = this.props, sortColumn = _a.sortColumn, sortDirection = _a.sortDirection, sortHandler = _a.sortHandler;
        if (sortColumn && sortDirection && sortHandler) {
            sortHandler(sortColumn, sortDirection);
        }
    };
    DataGrid.prototype.componentDidUpdate = function (prevProps) {
        var _this = this;
        if (prevProps.resetTick !== this.props.resetTick || prevProps.dataGridId !== this.props.dataGridId) {
            this.bootstrapTemplate();
        }
        if (prevProps.templates !== this.props.templates && this.props.templatesChanged === true && !this.state.templateDialogOpened) {
            this.setState({
                templateDialogOpened: true
            }, function () {
                _this.props.displayNotification({
                    autoDismiss: 0,
                    title: _this.state.wordings['datagrid.display.settings.changed'],
                    level: 'info',
                    position: 'tr',
                    message: _this.state.wordings['datagrid.save.display.settings'],
                    action: {
                        label: _this.state.wordings['datagrid.save'],
                        callback: function () {
                            _this.saveDataGridTemplate();
                        }
                    },
                    onRemove: function () {
                        _this.setState({
                            templateDialogOpened: false
                        });
                    }
                });
            });
        }
    };
    DataGrid.prototype.render = function () {
        var _this = this;
        var displayHiddenColumnsPanel = this.state.displayHiddenColumnsPanel;
        var _a = this.props, stickyHeader = _a.stickyHeader, selectHandler = _a.selectHandler, selectedItems = _a.selectedItems, selectionContextMenu = _a.selectionContextMenu, fetchingHeaders = _a.fetchingHeaders, preventTemplating = _a.preventTemplating, locale = _a.locale;
        var displayTemplate = this.getDisplayTemplate();
        var headerLine = (React.createElement(HeaderLine_1.default, { columnHeaders: this.props.columnHeaders, sortHandler: this.props.sortHandler, sortColumn: this.props.sortColumn, sortDirection: this.props.sortDirection, preventTemplating: preventTemplating, orderHandler: this.changeColumnOrder, widthHandler: this.changeColumnWidth, textAlignHandler: this.changeColumnTextAlign, displayHandler: this.changeColumnDisplay, templateChangeHandler: this.changeTemplate, displayNotification: this.props.displayNotification, displayContextMenu: this.displayContextMenu, hideContextMenu: this.hideContextMenu, stickyHeader: stickyHeader, displayTemplate: displayTemplate, locale: locale }));
        var hiddenColumnsPanel = this.getHiddenColumnsPanel();
        var templateBtns = [
            {
                btns: [{
                        clickAction: function () { return _this.resetTemplate(); },
                        cssClass: 'btn btn-danger btn-trans',
                        iconClass: 'fas fa-eraser',
                        tooltipText: this.state.wordings['datagrid.reset.templates']
                    }],
                cssClass: 'btn-group-xs'
            }
        ];
        if (hiddenColumnsPanel && !displayHiddenColumnsPanel) {
            templateBtns.unshift({
                btns: [{
                        clickAction: function () {
                            _this.setState({
                                displayHiddenColumnsPanel: !displayHiddenColumnsPanel
                            });
                        },
                        cssClass: 'btn btn-info btn-trans',
                        iconClass: 'fas fa-eye-slash',
                        tooltipText: this.state.wordings['datagrid.show.hidden.columns']
                    }],
                cssClass: 'btn-group-xs'
            });
        }
        return (fetchingHeaders ? React.createElement("div", null,
            React.createElement(spinner_1.default, null)) : (React.createElement("div", null,
            displayTemplate && !preventTemplating ? (React.createElement(buttons_bar_1.default, { locale: this.props.locale, btnGroups: templateBtns })) : null,
            displayHiddenColumnsPanel ? hiddenColumnsPanel : null,
            React.createElement("div", { style: { marginTop: 22, position: 'relative' } },
                headerLine,
                React.createElement("div", { className: classNames('cards-container row inline-items text-medium') },
                    React.createElement(SelectablesContainer_1.default, { orderedItems: this.getTemplateInjectedDataLines(), selectedItems: selectedItems || [], onSelect: selectHandler, contextMenuContent: selectionContextMenu, displayContextMenu: this.displayContextMenu, disableContextMenu: !selectionContextMenu, disableItemSelection: !selectHandler })),
                !this.props.fetchingItems && this.props.dataLines.length === 0 ? (React.createElement("div", { className: 'text-medium' }, this.props.noItemsMsg)) : null))));
    };
    DataGrid.select = function (state) {
        return {
            templates: state.datagrid.templates,
            templatesChanged: state.datagrid.templatesChanged,
            selectedAppInstanceName: state.main.selectedAppInstanceName,
            defaultServiceId: state.services.serviceId,
            user: state.main.user
        };
    };
    return DataGrid;
}(React.Component));
exports.DataGrid = DataGrid;
exports.default = react_redux_1.connect(DataGrid.select)(DataGrid);
//# sourceMappingURL=index.js.map