import { WebApi } from './WebApi';
import { Action } from './Actions';
import { DisplayTemplate } from './DisplayTemplate';
import { UserModel } from './UserModel';
import { ColumnHeader } from './DataGrid';
export interface DataGridActions {
    changeDisplayTemplate: (displayTemplate: DisplayTemplate, dataGridId: string, serviceId: string, instanceName: string) => Action;
    changeColumnOrder: (columnId: string, order: string, displayMode: string, dataGridId: string, serviceId: string, instanceName: string) => Action;
    changeColumnDisplay: (columnId: string, display: boolean, displayMode: string, dataGridId: string, serviceId: string, instanceName: string) => Action;
    changeColumnWidth: (columnId: string, way: string, displayMode: string, dataGridId: string, serviceId: string, instanceName: string) => Action;
    changeColumnTextAlign: (columnId: string, align: string, displayMode: string, dataGridId: string, serviceId: string, instanceName: string) => Action;
    saveUserDisplayTemplates: (api: WebApi, updatedData: UserModel) => any;
    userDisplayTemplatesUpdate: () => Action;
    bootstrapDataGridTemplate: (columnHeaders: ColumnHeader[], dataGridId: string, serviceId: string, instanceName: string) => Action;
    synchroniseDataGridTemplate: (columnHeaders: ColumnHeader[], dataGridId: string, serviceId: string, instanceName: string) => Action;
}
