/// <reference types="react" />
import * as React from 'react';
import { ThunkAction } from 'redux-thunk';
export declare type Endpoints = any;
export declare type Action = any;
export declare type GlobalState = any;
export declare type UserModel = any;
export declare module Auth {
    type AuthCodeData = any;
    type TokenData = any;
}
export interface Auth {
    AuthCodeData: any;
    TokenData: any;
}
export declare module NotificationModel {
    type Type = any;
}
export interface NotificationModel {
    Type: any;
}
export declare const api: {
    requestAuthorizationCode: (code: string, uname: string, pw: string, realm?: string, cctx?: string) => Promise<any>;
    requestAccessToken: (authorizationCode: string) => Promise<any>;
    requestClientAccessToken: () => Promise<any>;
    refreshAccessToken: () => Promise<any>;
    getWithClientToken: (url: string, clientAccessToken: string, queryParameters?: any, disableTimeout?: boolean) => Promise<any>;
    delWithClientToken: (url: string, clientAccessToken: string, queryParameters?: any, disableTimeout?: boolean) => Promise<any>;
    postWithClientToken: (url: string, clientAccessToken: string, bodyParameters?: any, queryParameters?: any, disableTimeout?: boolean) => Promise<any>;
    putWithClientToken: (url: string, clientAccessToken: string, bodyParameters?: any, queryParameters?: any, disableTimeout?: boolean) => Promise<any>;
    download: (url: string, queryParameters?: Object) => Promise<any>;
    staticGet: (url: string, queryParameters?: any, disableTimeout?: boolean, fullResponse?: boolean) => Promise<any>;
    get: (url: string, queryParameters?: any, disableTimeout?: boolean, fullResponse?: boolean) => Promise<any>;
    del: (url: string, queryParameters?: any, disableTimeout?: boolean, bodyParameters?: any) => Promise<any>;
    post: (url: string, bodyParameters?: any, queryParameters?: any, disableTimeout?: boolean, formUrlEncoded?: boolean) => Promise<any>;
    postWithFile: (url: string, fieldName: string, file: any, fieldsParameters?: {
        [fieldName: string]: string;
    }, queryParameters?: any) => Promise<any>;
    put: (url: string, bodyParameters?: any, queryParameters?: any, disableTimeout?: boolean) => Promise<any>;
    putWithFile: (url: string, fieldName: string, file: any, fieldsParameters?: {
        [fieldName: string]: string;
    }, queryParameters?: any) => Promise<any>;
    endpoints: {};
};
export declare function displayContextMenu(content: any, positionX?: number, positionY?: number): Action;
export declare function hideContextMenu(): Action;
export declare function receiveUserInfo(userInfo: UserModel): Action;
export declare function displayNotification(notificationType?: NotificationModel.Type, notificationOptions?: NotificationModel, displayParameter?: any): Action;
export declare function handleErrorDisplay(error: any): Action;
export declare function showDialog(title: string, body: React.ReactElement<any> | string, confirmAction?: Action | ThunkAction<void, GlobalState, any>, cancelAction?: Action | ThunkAction<void, GlobalState, any>, confirmLevel?: string, itemsList?: string[], modalReadyCallback?: () => void): Action;
export declare function hideDialog(): Action;
