/// <reference types="react" />
/**
 * Created by franckmontaigne on 14/06/16.
 */
import * as React from 'react';
import { DisplayTemplate } from '../models/DisplayTemplate';
declare module DataItem {
    interface Props extends React.Props<DataItem> {
        displayValue: JSX.Element | string;
        columnId: string;
        cssClass?: string;
        editCallback?: (key: string, value: string) => void;
        enterPressCallback?: () => void;
        tabOnLastCellCallback?: () => void;
        editMode?: boolean;
        readOnly?: boolean;
        isEdited?: boolean;
        lastEditable?: boolean;
        options?: {
            value: string | number;
            label?: string;
            disabled?: boolean;
        }[];
        validate?: (value: string) => any;
        displayTemplate?: DisplayTemplate;
    }
    interface State {
        showAsTextarea?: boolean;
        invalidMsg?: string;
    }
}
declare class DataItem extends React.Component<DataItem.Props, DataItem.State> {
    constructor(props: DataItem.Props);
    render(): JSX.Element;
    private closeTextareaDisplay;
    private toggleTextareaDisplay;
    private handleEdit;
    private keyPressHandler;
    private handleTabPress;
}
export default DataItem;
