"use strict";
/**
 * Created by franckmontaigne on 14/06/16.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
var DataItem = /** @class */ (function (_super) {
    __extends(DataItem, _super);
    function DataItem(props) {
        var _this = _super.call(this, props) || this;
        _this.closeTextareaDisplay = function (event) {
            //detect ESC key (onKeyUp event)
            if (event.keyCode === 27) {
                _this.setState({
                    showAsTextarea: false
                });
            }
        };
        _this.toggleTextareaDisplay = function () {
            _this.setState({ showAsTextarea: !_this.state.showAsTextarea });
        };
        _this.handleEdit = function (event) {
            var value = event.target.value;
            var invalidMsg = _this.props.validate && _this.props.validate(value) || undefined;
            if (invalidMsg !== _this.state.invalidMsg) {
                _this.setState({ invalidMsg: invalidMsg }, function () { return _this.props.editCallback(_this.props.columnId, value); });
            }
            else {
                _this.props.editCallback(_this.props.columnId, value);
            }
        };
        _this.keyPressHandler = function (event) {
            if (event.charCode === 13) {
                event.preventDefault();
                if (!_this.state.invalidMsg && _this.props.enterPressCallback && _this.props.isEdited) {
                    _this.props.enterPressCallback();
                }
            }
        };
        _this.handleTabPress = function (event) {
            if (event.keyCode === 9) {
                event.preventDefault();
                _this.props.tabOnLastCellCallback();
            }
        };
        _this.state = {
            showAsTextarea: false,
            invalidMsg: undefined
        };
        return _this;
    }
    DataItem.prototype.render = function () {
        var _a = this.props, options = _a.options, editCallback = _a.editCallback, editMode = _a.editMode, readOnly = _a.readOnly, isEdited = _a.isEdited, lastEditable = _a.lastEditable, tabOnLastCellCallback = _a.tabOnLastCellCallback, displayTemplate = _a.displayTemplate, displayValue = _a.displayValue, columnId = _a.columnId, cssClass = _a.cssClass;
        var itemDisplaySettings = displayTemplate ? displayTemplate[columnId] : null;
        //FIXME
        /* hardcoded access to desktop display mode */
        var userStyles = itemDisplaySettings ? {
            width: itemDisplaySettings.desktop.width,
            textAlign: itemDisplaySettings.desktop.textAlign,
            color: itemDisplaySettings.color
        } : {
            width: 150
        };
        var additionalProps = {};
        var editable = editCallback && editMode && !readOnly;
        var tabPressHandler = isEdited && lastEditable && tabOnLastCellCallback ? {
            onKeyDown: this.handleTabPress
        } : {};
        var _displayValue = editable ? ((options && options.length ? (React.createElement("div", { className: "form-inline" },
            React.createElement("select", { className: "form-control form-control-sm", onChange: this.handleEdit }, options.map(function (opt, idx) { return React.createElement("option", { key: idx, value: opt.value, disabled: opt.disabled }, opt.label || opt.value); })))) : (React.createElement("div", null,
            React.createElement("div", { className: "form-inline" },
                React.createElement("textarea", __assign({ className: classNames("form-control form-control-sm", {
                        "invalid": !!this.state.invalidMsg
                    }), value: displayValue || '', onChange: this.handleEdit, onKeyPress: this.keyPressHandler }, tabPressHandler))),
            !this.state.invalidMsg ? null : React.createElement("span", { className: 'danger-color text-xsmall' }, this.state.invalidMsg))))) : React.createElement("div", null, displayValue || '-');
        if (readOnly && typeof displayValue === 'string') {
            additionalProps.onDoubleClick = this.toggleTextareaDisplay;
            if (this.state.showAsTextarea) {
                _displayValue = (React.createElement("div", { className: "form-inline" },
                    React.createElement("textarea", { className: "form-control form-control-sm", value: displayValue || '', onKeyUp: this.closeTextareaDisplay, disabled: true, readOnly: true })));
            }
        }
        /* IMPORTANT - BE CAREFUL */
        /* the .dg-cell-edited is used in some files to select the first edited input of a datagrid ! */
        /* This shouldn't be modified without extra modifications on other parts of the project */
        return (React.createElement("div", __assign({ className: classNames('card-item-value inline-item-value', cssClass, {
                'dg-cell-edited': isEdited
            }), style: userStyles }, additionalProps), _displayValue));
    };
    return DataItem;
}(React.Component));
exports.default = DataItem;
//# sourceMappingURL=DataItem.js.map