"use strict";
/**
 * Created by franckmontaigne on 14/06/16.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Components 
var DataItem_1 = require("./components/DataItem");
var DataLine = /** @class */ (function (_super) {
    __extends(DataLine, _super);
    function DataLine(props) {
        return _super.call(this, props) || this;
    }
    DataLine.prototype.render = function () {
        var _a = this.props, displayTemplate = _a.displayTemplate, cells = _a.cells, editMode = _a.editMode, cellEditHandler = _a.cellEditHandler, tabOnLastCellCallback = _a.tabOnLastCellCallback, enterPressHandler = _a.enterPressHandler;
        var filteredAndSortedCells = cells;
        if (displayTemplate) {
            filteredAndSortedCells = cells.filter(function (cellData) {
                //FIXME
                /* hardcoded access to desktop display mode */
                if (displayTemplate[cellData.columnId]) {
                    return displayTemplate[cellData.columnId].desktop.display !== false;
                }
                return true;
            }).sort(function (cellA, cellB) {
                if (displayTemplate[cellA.columnId] && displayTemplate[cellA.columnId].desktop && displayTemplate[cellB.columnId] && displayTemplate[cellB.columnId].desktop) {
                    return displayTemplate[cellA.columnId].desktop.order - displayTemplate[cellB.columnId].desktop.order;
                }
                return 0;
            });
        }
        var cellsDisplay = filteredAndSortedCells.map(function (cellData, idx) {
            return (React.createElement(DataItem_1.default, { key: idx, columnId: cellData.columnId, displayValue: cellData.displayValue, cssClass: cellData.cssClass, displayTemplate: displayTemplate, editCallback: cellEditHandler, enterPressCallback: enterPressHandler, editMode: editMode, readOnly: cellData.readOnly, isEdited: cellData.isEdited, lastEditable: cellData.lastEditable, options: cellData.options, validate: cellData.validate, tabOnLastCellCallback: tabOnLastCellCallback }));
        });
        var additionalProps = {};
        if (this.props.sgleClickHandler) {
            additionalProps.onClick = this.props.sgleClickHandler;
        }
        if (this.props.dbleClickHandler) {
            additionalProps.onDoubleClick = this.props.dbleClickHandler;
        }
        return (React.createElement("div", __assign({ style: this.props.style, className: classNames(this.props.cssClass, 'card-item inline-item', {
                'dg-new-line': this.props.isNew
            }) }, additionalProps),
            React.createElement("div", { className: 'card-item-content' }, cellsDisplay)));
    };
    return DataLine;
}(React.Component));
exports.default = DataLine;
//# sourceMappingURL=index.js.map