"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var ReactDOM = require("react-dom");
var moment = require("moment");
var Pikaday = require("pikaday");
var classNames = require("classnames");
// Components
var help_1 = require("@amalto/help");
/**
 * Datepicker which display a calendar when being click on.
 * There is a few customizations like a minimum and a maximum date range
 * of date available.
 */
var DatePicker = /** @class */ (function (_super) {
    __extends(DatePicker, _super);
    function DatePicker(props) {
        var _this = _super.call(this, props) || this;
        _this._nameInput = HTMLInputElement = null;
        _this.setUpDatePicker = function () {
            var el = ReactDOM.findDOMNode(_this._nameInput);
            var component = _this;
            var config = {
                field: el,
                format: 'YYYY-MM-DD',
                position: 'bottom left',
                onSelect: function () {
                    if (component.props.handleDateChange) {
                        component.props.handleDateChange(picker.toString());
                    }
                    if (component.props.handleDateChangeEvent) {
                        var event_1 = {
                            target: {
                                value: picker.toString(),
                                name: component.props.name
                            }
                        };
                        component.props.handleDateChangeEvent(event_1);
                    }
                }
            };
            if (component.props.minDate) {
                config.minDate = moment(component.props.minDate).toDate();
            }
            if (component.props.maxDate) {
                config.maxDate = moment(component.props.maxDate).toDate();
            }
            var picker = new Pikaday(config);
            return picker;
        };
        _this.clearDate = function (event) {
            _this.state.datePickerInstance.setDate('', true);
            if (_this.props.handleDateChange) {
                _this.props.handleDateChange('');
            }
            if (_this.props.handleDateChangeEvent) {
                var clearEvent = {
                    target: {
                        value: '',
                        name: _this.props.name
                    }
                };
                _this.props.handleDateChangeEvent(clearEvent);
            }
        };
        _this.state = {
            datePickerInstance: null
        };
        return _this;
    }
    DatePicker.prototype.render = function () {
        var _this = this;
        if (this.props.mandatory && !this.props.defaultValue) {
            console.error('Mandatory DatePicker must have a defaultValue property (YYYY-MM-DD formatted string)');
            return null;
        }
        var disableClearBtn = true;
        if (this.state.datePickerInstance) {
            var picker = this.state.datePickerInstance;
            if (this.props.defaultValue && !this.props.mandatory) {
                disableClearBtn = false;
            }
        }
        return (React.createElement("div", { className: classNames(this.props.containerClass, {
                'form-group': this.props.mandatory || !!this.props.label,
                'mandatory pos-relative': this.props.mandatory
            }) },
            this.props.label ? React.createElement("label", null,
                this.props.label,
                this.props.help && React.createElement(help_1.default, { text: this.props.help })) : null,
            React.createElement("div", { style: { paddingTop: 1, paddingBottom: 1 }, className: "input-group input-group-sm" },
                React.createElement("input", { type: "text", className: "form-control datepicker", ref: function (dom) { return _this._nameInput = dom; }, readOnly: true, name: this.props.name }),
                React.createElement("span", { className: "input-group-btn" },
                    React.createElement("button", { disabled: disableClearBtn || this.props.mandatory, className: "btn btn-default", type: "button", onClick: this.clearDate },
                        React.createElement("span", { className: "fas fa-fw fa-times" }))))));
    };
    DatePicker.prototype.componentDidMount = function () {
        var picker = this.setUpDatePicker();
        this.setState({
            datePickerInstance: picker
        });
    };
    DatePicker.prototype.componentDidUpdate = function () {
        if (this.state.datePickerInstance) {
            var picker = this.state.datePickerInstance;
            if (this.props.defaultValue) {
                picker.setDate(moment(this.props.defaultValue).format(), true);
            }
            else {
                picker.setDate('', true);
            }
        }
    };
    DatePicker.prototype.componentWillUnmount = function () {
        if (this.state.datePickerInstance) {
            this.state.datePickerInstance.destroy();
        }
    };
    return DatePicker;
}(React.Component));
exports.default = DatePicker;
//# sourceMappingURL=index.js.map