"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
// Components
var spinner_1 = require("@amalto/spinner");
var DynamicComponent = /** @class */ (function (_super) {
    __extends(DynamicComponent, _super);
    function DynamicComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.refreshData = function () {
            _this.setState({
                preventRedraw: true
            }, function () {
                _this.props.refreshData();
            });
        };
        _this.getComponentDisplay = function () {
            var componentScript = _this.props.componentScript;
            var wordings = _this.state.wordings;
            var content = React.createElement("div", null);
            if (componentScript) {
                var dynamicComponent = eval(componentScript);
                if (dynamicComponent) {
                    _this.setState({
                        dynamicComponent: dynamicComponent.default || dynamicComponent
                    });
                    return (React.createElement(spinner_1.default, null));
                }
                else {
                    content = (React.createElement("div", { className: "text-medium danger-color", style: { lineHeight: '22px' } },
                        React.createElement("span", { className: "fas fa-exclamation-triangle right-spaced" }),
                        React.createElement("span", null, wordings['dynamiccomponent.error.loading'])));
                }
            }
            return (React.createElement("div", null, content));
        };
        _this.state = {
            dynamicComponent: null,
            display: null,
            preventRedraw: false,
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    DynamicComponent.prototype.render = function () {
        var _a = this.props, componentData = _a.componentData, height = _a.height, fullscreen = _a.fullscreen, setFullscreen = _a.setFullscreen, showDialog = _a.showDialog, hideDialog = _a.hideDialog, displayNotification = _a.displayNotification, handleErrorDisplay = _a.handleErrorDisplay, setStatus = _a.setStatus, storeContext = _a.storeContext, contextData = _a.contextData, reloadTooltips = _a.reloadTooltips, showJobStatus = _a.showJobStatus, selectedAppKey = _a.selectedAppKey, selectedAppKeyName = _a.selectedAppKeyName, canSelectAppKey = _a.canSelectAppKey, hasAppKeyInstalled = _a.hasAppKeyInstalled, api = _a.api, appHistory = _a.appHistory;
        var componentProps = {
            data: componentData,
            api: api,
            appHistory: appHistory,
            height: height,
            fullscreen: fullscreen,
            setFullscreen: setFullscreen,
            refreshData: this.refreshData,
            showDialog: showDialog,
            hideDialog: hideDialog,
            displayNotification: displayNotification,
            handleErrorDisplay: handleErrorDisplay,
            setStatus: setStatus,
            storeContext: storeContext,
            contextData: contextData,
            reloadTooltips: reloadTooltips,
            showJobStatus: showJobStatus,
            canSelectAppKey: canSelectAppKey,
            selectedAppKey: selectedAppKey,
            selectedAppKeyName: selectedAppKeyName,
            hasAppKeyInstalled: hasAppKeyInstalled
        };
        return (React.createElement("div", null, this.state.dynamicComponent ? (React.createElement(this.state.dynamicComponent, __assign({}, componentProps))) : this.state.display));
    };
    DynamicComponent.prototype.componentDidMount = function () {
        this.setState({
            display: this.getComponentDisplay()
        });
    };
    DynamicComponent.prototype.componentDidUpdate = function (prevProps, prevState) {
        if ((this.state.preventRedraw !== true) && (prevProps.componentScript !== this.props.componentScript) || (prevProps.componentData !== this.props.componentData)) {
            this.setState({
                display: this.getComponentDisplay()
            });
        }
    };
    return DynamicComponent;
}(React.Component));
exports.default = DynamicComponent;
//# sourceMappingURL=index.js.map