/**
 * Created by franckmontaigne on 20/07/15.
 */
declare module NotificationModel {
    interface Action {
        label: string;
        callback: () => void;
    }
    enum Type {
        APP_LOADED = 0,
        SUCCESS_CREATE = 1,
        SUCCESS_UPDATE = 2,
        SUCCESS_DELETE = 3,
        INVALID_PASSWORD = 4,
        INVALID_EMAIL = 5,
        CARD_TEMPLATE_ITEM_FULL = 6,
        INVALID_COLOR_CODE = 7,
        EMPTY_VALUE = 8,
        XHR_ERROR = 9,
        PASSWORD_UPDATED = 10,
        DETAILS_UPDATED = 11,
        SETTINGS_UPDATED = 12,
        AVATAR_UPDATED = 13,
        USER_ASSOCIATED = 14,
        USER_ASSOCIATE_RESEND = 15,
        USER_DISASSOCIATED = 16,
        MESSAGE_DELETED = 17,
        MESSAGE_REPROCESSED = 18,
        USER_EXISTS = 19,
        UNEXPECTED_ERROR = 20,
        REGISTRATION_UNAVAILABLE = 21,
    }
    interface Details {
        notificationType?: Type;
        displayParameter?: any;
        notificationOptions?: NotificationModel;
    }
}
interface NotificationModel {
    title?: string;
    message: string;
    level: string;
    position?: string;
    autoDismiss?: number;
    dismissible?: boolean;
    action?: NotificationModel.Action;
    onRemove?: () => void;
}
export default NotificationModel;
