/// <reference types="react" />
import * as React from 'react';
/**
 * Modal use to confirm a file upload.
 */
declare module FileImporter {
    interface Props extends React.Props<FileImporter> {
        /** File to be imported. */
        fileData: File;
        /** Close the modal. */
        cancelHandler: () => void;
        /** Submit your file. */
        submitHandler: (fileType: string, hasHeaders: boolean, overwrite: boolean, fileEncoding: string, fileSeparator: string, fileQuoteChar: string) => void;
        /** Display file's specifications. */
        hideControls?: {
            fileType?: boolean;
            separator?: boolean;
            quoteChar?: boolean;
            encoding?: boolean;
            headers?: boolean;
            overwrite?: boolean;
        };
        /** Is being processed, if true display the spinner. */
        processing?: boolean;
        /** Locale to be used. */
        locale: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<FileImporter>;
    }
    interface State {
        wordings?: {
            [key: string]: string;
        };
        impFileType?: string;
        impFileHasHeaders?: boolean;
        impFileOverwrite?: boolean;
        impFileEncoding?: string;
        impFileSeparator?: string;
        impFileQuoteChar?: string;
    }
}
declare class FileImporter extends React.Component<FileImporter.Props, FileImporter.State> {
    constructor(props: FileImporter.Props);
    render(): JSX.Element;
    private submitHandler;
    private handleConfigChange;
    private handleConfigSwitchChange;
}
export default FileImporter;
