"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
// Components
var switch_1 = require("@amalto/switch");
var spinner_1 = require("@amalto/spinner");
var FileImporter = /** @class */ (function (_super) {
    __extends(FileImporter, _super);
    function FileImporter(props) {
        var _this = _super.call(this, props) || this;
        _this.submitHandler = function () {
            var data = _this.state;
            _this.props.submitHandler(data.impFileType, data.impFileHasHeaders, data.impFileOverwrite, data.impFileEncoding, data.impFileSeparator, data.impFileQuoteChar);
        };
        _this.handleConfigChange = function (event) {
            var stateUpdate = {};
            stateUpdate[event.target.name] = event.target.value;
            _this.setState(stateUpdate);
        };
        _this.handleConfigSwitchChange = function (switchValue, configKey) {
            var stateUpdate = {};
            stateUpdate[configKey] = switchValue;
            _this.setState(stateUpdate);
        };
        _this.state = {
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale),
            impFileType: _this.props.fileData.name.toLowerCase().indexOf('.csv') !== -1 ? 'CSV' : 'EXCEL',
            impFileHasHeaders: true,
            impFileOverwrite: false,
            impFileEncoding: 'utf-8',
            impFileSeparator: ',',
            impFileQuoteChar: '\''
        };
        return _this;
    }
    FileImporter.prototype.render = function () {
        var hideControls = this.props.hideControls || {};
        return (React.createElement("div", { className: "form-dialog" },
            React.createElement("div", { className: "col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2 col-lg-6 col-lg-offset-3" },
                React.createElement("div", { className: "panel panel-default" },
                    React.createElement("div", { className: "panel-heading" },
                        React.createElement("h3", { className: classNames('panel-title', {
                                'has-spinner': this.props.processing
                            }) }, this.state.wordings['fileimporter.title']),
                        this.props.processing && React.createElement("div", { className: "spinner-container" },
                            React.createElement(spinner_1.default, null))),
                    React.createElement("div", { className: "panel-body" },
                        React.createElement("div", { className: "row bottom-margin" },
                            React.createElement("div", { className: "col-xs-12 text-center toggle-form" },
                                React.createElement("h5", { className: "upper bottom-margin" }, this.state.wordings['fileimporter.sub.title']),
                                React.createElement("p", { className: "bottom-spaced" },
                                    React.createElement("span", { className: "label label-success text-small" }, this.state.wordings['fileimporter.file.name']),
                                    React.createElement("br", null),
                                    React.createElement("em", null, this.props.fileData.name)),
                                React.createElement("p", { className: "margin-none" },
                                    React.createElement("span", { className: "label label-success text-small" }, this.state.wordings['fileimporter.file.size']),
                                    React.createElement("br", null),
                                    React.createElement("em", null, helpers_1.formatFileSize(this.props.fileData.size))))),
                        React.createElement("div", { className: "row bottom-margin" },
                            React.createElement("div", { className: classNames('col-xs-12 col-sm-6', { 'hidden': hideControls.fileType === true }) },
                                React.createElement("div", { className: "form-group" },
                                    React.createElement("label", null, this.state.wordings['fileimporter.file.type']),
                                    React.createElement("select", { className: "form-control", name: "impFileType", onChange: this.handleConfigChange, value: this.state.impFileType },
                                        React.createElement("option", { value: "CSV" }, "CSV"),
                                        React.createElement("option", { value: "EXCEL" }, "Excel")))),
                            React.createElement("div", { className: classNames('col-xs-12 col-sm-6', {
                                    'hidden': this.state.impFileType === 'EXCEL' || hideControls.separator === true
                                }) },
                                React.createElement("div", { className: "form-group" },
                                    React.createElement("label", null, this.state.wordings['fileimporter.file.fields.separator']),
                                    React.createElement("select", { className: "form-control", name: "impFileSeparator", onChange: this.handleConfigChange, value: this.state.impFileSeparator, disabled: this.state.impFileType === 'EXCEL' },
                                        React.createElement("option", { value: "," }, ","),
                                        React.createElement("option", { value: ";" }, ";")))),
                            React.createElement("div", { className: classNames('col-xs-12 col-sm-6', {
                                    'hidden': this.state.impFileType === 'EXCEL' || hideControls.quoteChar === true
                                }) },
                                React.createElement("div", { className: "form-group" },
                                    React.createElement("label", null, this.state.wordings['fileimporter.file.quote.char']),
                                    React.createElement("select", { className: "form-control", name: "impFileQuoteChar", onChange: this.handleConfigChange, value: this.state.impFileQuoteChar, disabled: this.state.impFileType === 'EXCEL' },
                                        React.createElement("option", { value: "'" }, "'"),
                                        React.createElement("option", { value: '"' }, "\""),
                                        React.createElement("option", { value: "" }, this.state.wordings['fileimporter.none'])))),
                            React.createElement("div", { className: classNames('col-xs-12 col-sm-6', {
                                    'hidden': this.state.impFileType === 'EXCEL' || hideControls.encoding === true
                                }) },
                                React.createElement("div", { className: "form-group" },
                                    React.createElement("label", null, this.state.wordings['fileimporter.file.encoding']),
                                    React.createElement("select", { className: "form-control", name: "impFileEncoding", onChange: this.handleConfigChange, value: this.state.impFileEncoding, disabled: this.state.impFileType === 'EXCEL' },
                                        React.createElement("option", { value: "utf-8" }, "utf-8"),
                                        React.createElement("option", { value: "iso8859-1" }, "iso8859-1"),
                                        React.createElement("option", { value: "cp-1252" }, "cp-1252")))),
                            React.createElement("div", { className: classNames('col-xs-12 col-sm-6', {
                                    'hidden': hideControls.headers === true
                                }) },
                                React.createElement("div", { className: "form-group" },
                                    React.createElement("label", null, this.state.wordings['fileimporter.file.has.headers']),
                                    React.createElement(switch_1.default, { id: "fileImporterHasHeaders", value: this.state.impFileHasHeaders, name: "impFileHasHeaders", alignLeft: true, changeHandler: this.handleConfigSwitchChange }))),
                            React.createElement("div", { className: classNames('col-xs-12 col-sm-6', {
                                    'hidden': hideControls.overwrite === true
                                }) },
                                React.createElement("div", { className: "form-group" },
                                    React.createElement("label", null, this.state.wordings['fileimporter.file.overwrite.existing']),
                                    React.createElement(switch_1.default, { id: "fileImporterOverwrite", value: this.state.impFileOverwrite, name: "impFileOverwrite", alignLeft: true, changeHandler: this.handleConfigSwitchChange }))))),
                    React.createElement("div", { className: "panel-footer" },
                        React.createElement("button", { type: "button", className: "btn btn-font btn-trans", onClick: this.props.cancelHandler }, this.state.wordings['fileimporter.button.cancel']),
                        React.createElement("button", { type: "button", className: "btn btn-success pull-right", onClick: this.submitHandler, disabled: this.props.processing }, this.state.wordings['fileimporter.button.submit']))))));
    };
    return FileImporter;
}(React.Component));
exports.default = FileImporter;
//# sourceMappingURL=index.js.map