"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Utils
var helpers_1 = require("@amalto/helpers");
var FileWrapper = /** @class */ (function (_super) {
    __extends(FileWrapper, _super);
    function FileWrapper(props) {
        var _this = _super.call(this, props) || this;
        _this.deleteUploadedFile = function (event) {
            var fileName = event.currentTarget.getAttribute('data-file-name');
            _this.props.deleteUploadedFile(fileName);
        };
        return _this;
    }
    FileWrapper.prototype.render = function () {
        var progressDisplay = this.props.progress ? (React.createElement("div", { className: "file-upload-progress", style: { width: this.props.progress + '%' } })) : !this.props.uploaded ? React.createElement("div", { className: "bar-load" }) : null;
        var deleteBtn = (this.props.uploaded && !this.props.processSuccess) ? (React.createElement("div", { "data-file-name": this.props.fileName, className: "file-icon-cell file-delete-btn", onClick: this.deleteUploadedFile },
            React.createElement("span", { className: "fas fa-fw fa-trash-alt" }))) : null;
        var successIcon = this.props.processSuccess ? (React.createElement("div", { className: "file-icon-cell" },
            React.createElement("span", { className: "fas fa-fw fa-check" }))) : null;
        var createdMessageText = this.props.successMessage || null;
        var errorMessage = (this.props.processSuccess === false && this.props.message) ? (React.createElement("div", { className: "file-error-row" },
            React.createElement("div", { className: "file-error-message" },
                React.createElement("span", { className: "fas fa-exclamation-triangle right-spaced" }),
                React.createElement("span", { dangerouslySetInnerHTML: { __html: this.props.message } })),
            React.createElement("div", null, "\u00A0"))) : null;
        return (React.createElement("li", { className: classNames({
                'success-color': this.props.processSuccess,
                'warning-color': this.props.processState === 'WARNING',
                'danger-color': this.props.processState === 'ERROR',
                'bar-loading-wrapper': !this.props.uploaded
            }) },
            progressDisplay,
            React.createElement("div", { className: "file-details" },
                React.createElement("span", { className: "file-name", "data-toggle": "tooltip", "data-original-title": createdMessageText }, this.props.fileName),
                React.createElement("span", { className: "file-size" }, helpers_1.formatFileSize(this.props.fileSize))),
            deleteBtn,
            successIcon,
            errorMessage));
    };
    return FileWrapper;
}(React.Component));
exports.default = FileWrapper;
//# sourceMappingURL=FileWrapper.js.map