"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var react_dropzone_1 = require("react-dropzone");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
// Components
var FileWrapper_1 = require("./components/FileWrapper");
/**
 * FileInput allow you to upload several files.
 * You can click or drag and drop inside the block to do so.
 */
var FileInput = /** @class */ (function (_super) {
    __extends(FileInput, _super);
    function FileInput(props) {
        var _this = _super.call(this, props) || this;
        _this.onDrop = function (files, rejectedFiles) {
            if (files.length) {
                _this.props.addFilesToQueue(files);
            }
            if (rejectedFiles.length) {
                _this.setState({
                    invalidFiles: _this.state.invalidFiles.concat(rejectedFiles)
                });
            }
        };
        _this.closeInvalidFilesAlert = function () {
            _this.setState({
                invalidFiles: []
            });
        };
        _this.deleteUploadedFile = function (fileName) {
            _this.props.deleteUploadedFile(fileName);
        };
        _this.state = {
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale),
            submitDisabled: false,
            invalidFiles: []
        };
        return _this;
    }
    FileInput.prototype.render = function () {
        var _this = this;
        var filesQueue = this.props.filesQueue;
        var files = $.map(filesQueue, function (file, key) { return file; });
        var filesDisplay = files.map(function (file, idx) {
            return (React.createElement(FileWrapper_1.default, { key: idx, fileName: file.sourceFile.name, fileSize: file.sourceFile.size, deleteUploadedFile: _this.deleteUploadedFile, uploaded: file.uploadEnded, progress: file.uploadProgress, processSuccess: file.processSuccess, processState: file.processState }));
        });
        var dropzone = (React.createElement(react_dropzone_1.default, { className: "col-xs-12 file-drop-zone", onDrop: this.onDrop, disableClick: this.state.submitDisabled, accept: this.props.mimeTypeAccepted, maxSize: this.props.maxBytesSize },
            React.createElement("div", { className: "drop-zone-title" },
                React.createElement("span", null, this.state.wordings['fileinput.drop.zone.title']),
                React.createElement("br", null),
                React.createElement("span", { className: "subtitle" }, this.state.wordings['fileinput.drop.zone.subtitle']))));
        var cancelBtn = (React.createElement("div", { className: "top-margin" },
            React.createElement("button", { type: "button", className: "btn btn-sm btn-danger btn-trans", onClick: this.props.cancelSubmit }, this.state.wordings['fileinput.button.cancel'])));
        var errors = this.state.invalidFiles.map(function (file, idx) {
            return (React.createElement("div", { key: idx },
                React.createElement("span", null,
                    React.createElement("strong", null, file.name),
                    " - "),
                React.createElement("em", null,
                    helpers_1.formatFileSize(file.size),
                    ", ",
                    file.type || _this.state.wordings['fileinput.unknown.format'])));
        });
        return (React.createElement("div", { className: "file-input" },
            React.createElement("div", { className: "row" },
                React.createElement("div", { className: "col-xs-12 col-sm-5" }, dropzone),
                React.createElement("div", { className: "col-xs-12 col-sm-7" },
                    React.createElement("div", { className: "file-list" },
                        React.createElement("ul", { style: { margin: 0 } }, filesDisplay),
                        this.state.invalidFiles.length ? (React.createElement("div", { className: "alert alert-danger alert-dismissable top-margin text-medium" },
                            React.createElement("button", { type: "button", className: "close", onClick: this.closeInvalidFilesAlert }, "\u00D7"),
                            React.createElement("div", { className: "bottom-spaced" },
                                React.createElement("strong", { className: "right-spaced" }, this.state.wordings['fileinput.invalid.file']),
                                React.createElement("span", { className: "fas fa-info-circle click-pointer", "data-toggle": "collapse", "data-target": "#inputFormatInfo" }),
                                React.createElement("div", { id: "inputFormatInfo", className: "collapse top-spaced font-color", style: { paddingLeft: 20 } },
                                    this.props.mimeTypeAccepted ? React.createElement("div", null,
                                        React.createElement("strong", { className: "right-spaced" }, this.state.wordings['fileinput.content.type']),
                                        React.createElement("span", null, this.props.mimeTypeAccepted)) : null,
                                    this.props.maxBytesSize ? React.createElement("div", null,
                                        React.createElement("strong", { className: "right-spaced" }, this.state.wordings['fileinput.max.size']),
                                        React.createElement("span", null, helpers_1.formatFileSize(this.props.maxBytesSize))) : null)),
                            errors)) : null))),
            cancelBtn));
    };
    return FileInput;
}(React.Component));
exports.default = FileInput;
//# sourceMappingURL=index.js.map