"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by Christopher VUONG
 */
var React = require("react");
// Modules
var redux_form_1 = require("redux-form");
// Components
var help_1 = require("@amalto/help");
// Utils
var classNames = require("classnames");
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
var FileInput = /** @class */ (function (_super) {
    __extends(FileInput, _super);
    function FileInput(props) {
        var _this = _super.call(this, props) || this;
        _this.setValue = function (event, field) {
            _this.setState({ loadingError: false });
            var input = field.input, meta = field.meta;
            var file = event.target.files[0];
            var reader = new FileReader();
            if (file) {
                reader.onload = function (e) {
                    _this.setState({ fileContent: reader.result });
                };
                reader.onerror = function (e) {
                    _this.setState({ loadingError: true });
                };
                reader.readAsText(file);
                _this.setState({ filename: file.name, filesize: file.size }, function () { return input.onChange(file, undefined, undefined); });
            }
        };
        _this.state = {
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale),
            loadingError: false,
            fileContent: null,
            filename: null,
            filesize: null
        };
        return _this;
    }
    FileInput.prototype.render = function () {
        var _this = this;
        var _a = this.state, filename = _a.filename, filesize = _a.filesize, fileContent = _a.fileContent, wordings = _a.wordings;
        var _b = this.props, label = _b.label, disabled = _b.disabled, help = _b.help, containerClass = _b.containerClass, inputClass = _b.inputClass, name = _b.name, displayPreview = _b.displayPreview, collapseErrorSpace = _b.collapseErrorSpace, input = _b.input, meta = _b.meta;
        var fileUploaded = !!input.value;
        return (React.createElement("div", { className: classNames('form-group', containerClass, {
                'invalid': meta.touched && !!meta.error || this.state.loadingError
            }) },
            label ? React.createElement("label", null,
                label,
                help && React.createElement(help_1.default, { text: help })) : null,
            React.createElement("div", { className: 'form-control pos-relative' },
                React.createElement("input", { name: name, type: "file", disabled: disabled, className: classNames('pos-absolute upload-input default-pointer', inputClass), onChange: function (e) { _this.setValue(e, { input: input, meta: meta }); } }),
                React.createElement("span", { className: 'fas fa-upload primary-color mgr-10' }),
                !!filename && !!filesize
                    ? React.createElement("span", { className: 'italic' },
                        React.createElement("span", null,
                            React.createElement("span", { className: 'black-color bold' },
                                wordings['name'],
                                ":"),
                            " ",
                            filename),
                        ", ",
                        React.createElement("span", null,
                            React.createElement("span", { className: 'black-color bold' },
                                wordings['size'],
                                ":"),
                            " ",
                            helpers_1.formatFileSize(filesize)))
                    : !fileUploaded ? React.createElement("span", { className: 'italic' }, wordings['noFileChosen']) : React.createElement("span", { className: 'italic' }, wordings['fileUploaded'])),
            (meta.touched && !!meta.error) ? React.createElement("p", { className: "validation-error-message" }, meta.error) : (collapseErrorSpace || this.state.loadingError ? null : React.createElement("p", { className: "validation-error-message" }, "\u00A0")),
            (input.value && displayPreview && fileContent) ?
                React.createElement("div", { className: "hidden-xs top-spaced" },
                    React.createElement("em", null,
                        React.createElement("small", null,
                            label && React.createElement("span", { className: "right-spaced" }, label),
                            wordings['previewLowerCase'])),
                    React.createElement("pre", { className: "code-preview-sm" }, fileContent)) : null,
            this.state.loadingError ? React.createElement("p", { className: "validation-error-message" }, wordings['fileUploadFailed']) : null));
    };
    return FileInput;
}(React.Component));
var FileUploadInput = /** @class */ (function (_super) {
    __extends(FileUploadInput, _super);
    function FileUploadInput(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    FileUploadInput.prototype.render = function () {
        var _a = this.props, name = _a.name, label = _a.label, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn,
            component: FileInput
        };
        return React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, this.props));
    };
    return FileUploadInput;
}(React.Component));
exports.default = FileUploadInput;
//# sourceMappingURL=index.js.map