"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
//get error message giving the locale data string ID
var error = function (id, locale) {
    var wordings = helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, locale);
    return wordings[id] || wordings['invalidField'] || 'Error';
};
exports.checked = function (value, locale) { return value ? undefined : error('fieldRequired', locale); };
exports.required = function (value, locale) { return helpers_1.isNotEmpty(value) ? undefined : error('fieldRequired', locale); };
exports.email = function (value, locale) { return helpers_1.isValidEmail(value) ? undefined : error('invalidEmail', locale); };
exports.number = function (value, locale) { return value && isNaN(Number(value)) ? error('invalidNumber', locale) : undefined; };
exports.https = function (value, locale) { return value && helpers_1.isValidHttpsUrl(value) ? undefined : error('invalidUrl', locale); };
//# sourceMappingURL=index.js.map