/// <reference types="react" />
import * as React from 'react';
/**
 * Language selector.
 */
declare module LanguageWrapper {
    interface Props extends React.Props<LanguageWrapper> {
        /** Current selected language. */
        selectedLanguage: string;
        /** Array of language selected. */
        supportedLanguages: string[];
        /** Select language event. */
        handleLanguageChange: (language: string) => void;
        /** Add language event. */
        handleAddedLanguage: (language: string) => void;
        /** Remove language event. */
        handleRemovedLanguage: (language: string) => void;
        /** CSS Class of the div root component. */
        containerClass?: string;
        /** Language selected. */
        locale: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<LanguageWrapper>;
    }
    interface State {
        addOpen?: boolean;
        wordings?: {
            [id: string]: string;
        };
    }
}
declare class LanguageWrapper extends React.Component<LanguageWrapper.Props, LanguageWrapper.State> {
    constructor(props: LanguageWrapper.Props);
    render(): JSX.Element;
    private getLanguagesSelector;
    private handleLanguageSelection;
    private getSelectedLanguage;
}
export default LanguageWrapper;
