"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
// Constants
var Data_1 = require("./constants/Data");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
// Components
var typeahead_input_1 = require("@amalto/typeahead-input");
var LanguageWrapper = /** @class */ (function (_super) {
    __extends(LanguageWrapper, _super);
    function LanguageWrapper(props) {
        var _this = _super.call(this, props) || this;
        _this.getLanguagesSelector = function () {
            var _a = _this.state, addOpen = _a.addOpen, wordings = _a.wordings;
            return addOpen ? (React.createElement("span", { className: "mgl-10 inline-middle" },
                React.createElement(typeahead_input_1.default, { id: "languageWrapperSelector", handleInputChange: _this.handleLanguageSelection, value: _this.getSelectedLanguage(), collection: Data_1.languageIso, display: function (lang) { return lang && lang.languageCode && lang.languageCode + " - " + lang.languageName; }, datumTokenizer: function (lang) { return [lang.languageCode, lang.languageName]; }, placeholder: wordings['languagewrapper.search'] }))) : (React.createElement("button", { className: "btn btn-sm btn-trans btn-info mgl-10", type: "button", onClick: function () { _this.setState({ addOpen: true }); }, "data-toggle": "tooltip", "data-original-title": wordings['languagewrapper.add.one'] },
                React.createElement("span", { className: "fas fa-plus" })));
        };
        _this.handleLanguageSelection = function (lang) {
            var _a = _this.props, supportedLanguages = _a.supportedLanguages, handleAddedLanguage = _a.handleAddedLanguage;
            var selectedLanguage = Data_1.languageIso.filter(function (language) { return lang && language.languageCode === lang.languageCode; });
            if (selectedLanguage.length === 1) {
                handleAddedLanguage(lang.languageCode);
                _this.setState({
                    addOpen: false
                });
            }
        };
        _this.getSelectedLanguage = function () {
            var selectedLanguage = Data_1.languageIso.filter(function (lang) { return lang.languageCode === _this.props.selectedLanguage; });
            return selectedLanguage.length === 1 ? selectedLanguage[0] : undefined;
        };
        _this.state = {
            addOpen: false,
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    LanguageWrapper.prototype.render = function () {
        var _this = this;
        var _a = this.state, addOpen = _a.addOpen, wordings = _a.wordings;
        var _b = this.props, selectedLanguage = _b.selectedLanguage, handleLanguageChange = _b.handleLanguageChange, handleRemovedLanguage = _b.handleRemovedLanguage, containerClass = _b.containerClass;
        return (React.createElement("div", { className: containerClass },
            React.createElement("div", { className: "form-inline" },
                React.createElement("label", null, wordings['languagewrapper.selected']),
                React.createElement("select", { className: "form-control mgl-10", value: selectedLanguage, onChange: function (e) { return handleLanguageChange(e.target.value); } }, this.props.supportedLanguages.map(function (lang, idx) { return (React.createElement("option", { key: idx, value: lang }, lang)); })),
                this.getLanguagesSelector(),
                addOpen ? React.createElement("button", { className: 'btn btn-sm btn-trans btn-font mgl-10', type: 'button', onClick: function () { _this.setState({ addOpen: false }); }, "data-toggle": 'tooltip', "data-original-title": wordings['languagewrapper.close.selector'] },
                    React.createElement("span", { className: "fas fa-times" })) : null,
                selectedLanguage ? (React.createElement("button", { type: 'button', className: "btn btn-sm btn-trans btn-danger mgl-10", onClick: function (e) { e.preventDefault(); handleRemovedLanguage(selectedLanguage); }, "data-toggle": "tooltip", "data-original-title": wordings['languagewrapper.remove.selected'] },
                    React.createElement("span", { className: "fas fa-minus" }))) : null)));
    };
    return LanguageWrapper;
}(React.Component));
exports.default = LanguageWrapper;
//# sourceMappingURL=index.js.map