/// <reference types="react" />
import * as React from 'react';
/**
 * Page navigation toolbar.
 */
declare module PagingControls {
    interface Props extends React.Props<PagingControls> {
        /** Class for the PagingControls component. */
        containerClass: string;
        /** Current page selected. */
        currentPage: number;
        /** Total page */
        totalPages: number;
        /** Method triggered when changing page. */
        handlePageChange: (newPage: number | string) => void;
        /** Get previous and next context from the handlePageChange props. */
        byContext?: {
            prevContextToken: string;
            nextContextToken: string;
        };
        /** Locale to bu used. */
        locale: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<PagingControls>;
    }
    interface State {
        wordings?: {
            [key: string]: string;
        };
    }
}
declare class PagingControls extends React.Component<PagingControls.Props, PagingControls.State> {
    constructor(props: PagingControls.Props);
    render(): JSX.Element;
    private goToFirstPage;
    private goToNextPage;
    private goToPrevPage;
    private goToLastPage;
}
export default PagingControls;
