"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var react_intl_1 = require("react-intl");
// Utils
var helpers_1 = require("@amalto/helpers");
// Wordings
var wordings_1 = require("@amalto/wordings");
var PagingControls = /** @class */ (function (_super) {
    __extends(PagingControls, _super);
    function PagingControls(props) {
        var _this = _super.call(this, props) || this;
        _this.goToFirstPage = function (event) {
            $(event.currentTarget).blur(); //removes active state on the button
            _this.props.handlePageChange(1);
        };
        _this.goToNextPage = function (event) {
            $(event.currentTarget).blur();
            var _a = _this.props, byContext = _a.byContext, handlePageChange = _a.handlePageChange;
            if (byContext) {
                handlePageChange(byContext.nextContextToken);
            }
            else {
                handlePageChange(_this.props.currentPage + 1);
            }
        };
        _this.goToPrevPage = function (event) {
            $(event.currentTarget).blur();
            var _a = _this.props, byContext = _a.byContext, handlePageChange = _a.handlePageChange;
            if (byContext) {
                handlePageChange(byContext.prevContextToken);
            }
            else {
                handlePageChange(_this.props.currentPage - 1);
            }
        };
        _this.goToLastPage = function (event) {
            $(event.currentTarget).blur();
            _this.props.handlePageChange(_this.props.totalPages);
        };
        _this.state = {
            wordings: helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, props.locale)
        };
        return _this;
    }
    PagingControls.prototype.render = function () {
        var _a = this.props, containerClass = _a.containerClass, currentPage = _a.currentPage, totalPages = _a.totalPages, byContext = _a.byContext;
        //basic paging control by page number
        var prevDisabled = currentPage === 1;
        var nextDisabled = totalPages === 1 || (currentPage === totalPages);
        //paging control by context tokens
        if (byContext) {
            prevDisabled = !byContext.prevContextToken;
            nextDisabled = !byContext.nextContextToken;
        }
        return (totalPages !== 1 ? (React.createElement("div", { className: containerClass },
            byContext ? null : (React.createElement("button", { type: "button", disabled: prevDisabled, className: "btn btn-primary btn-trans", onClick: this.goToFirstPage },
                React.createElement("span", { className: "fas fa-fw fa-fast-backward" }))),
            React.createElement("button", { type: "button", disabled: prevDisabled, className: "btn btn-primary btn-trans", onClick: this.goToPrevPage },
                React.createElement("span", { className: "fas fa-fw fa-backward" })),
            React.createElement("span", { className: "btn btn-primary btn-trans text-element no-border-right" },
                React.createElement("span", { className: "right-spaced" }, this.state.wordings['pagingcontrols.page']),
                React.createElement("strong", { className: "right-spaced" },
                    React.createElement(react_intl_1.FormattedNumber, { value: currentPage })),
                React.createElement("span", { className: "right-spaced" }, this.state.wordings['pagingcontrols.page.of']),
                React.createElement("span", null,
                    React.createElement(react_intl_1.FormattedNumber, { value: totalPages }))),
            React.createElement("button", { type: "button", disabled: nextDisabled, className: "btn btn-primary btn-trans", onClick: this.goToNextPage },
                React.createElement("span", { className: "fas fa-fw fa-forward" })),
            byContext ? null : (React.createElement("button", { type: "button", disabled: nextDisabled, className: "btn btn-primary btn-trans", onClick: this.goToLastPage },
                React.createElement("span", { className: "fas fa-fw fa-fast-forward" }))))) : null);
    };
    return PagingControls;
}(React.Component));
exports.default = PagingControls;
//# sourceMappingURL=index.js.map