/// <reference types="pdf" />
/// <reference types="react" />
import * as React from 'react';
/**
 * Display pdf content.
 */
declare namespace PdfViewer {
    interface Props extends React.Props<PdfViewer> {
        /** Pdf data. More details on [PDFSource](http://localhost:6060/#pdfsource). */
        pdfSource: PDFSource;
        /** Class of the PdfViewer component. */
        containerClass?: string;
        /** React CSS properties object to apply to PdfViewer. */
        style?: React.CSSProperties;
        /** Update value to force update. */
        reloadTick?: number;
        /** Locale to be used. */
        locale: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<PdfViewer>;
    }
    interface State {
        wordings?: {
            [key: string]: string;
        };
        pdf?: PDFDocumentProxy;
        loading?: boolean;
        loadingError?: boolean;
        currentPage?: number;
    }
}
declare class PdfViewer extends React.Component<PdfViewer.Props, PdfViewer.State> {
    private pdfCtn;
    constructor(props: PdfViewer.Props);
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: PdfViewer.Props): void;
    private getPagingControls;
    private loadPDF;
    private renderPage;
}
export default PdfViewer;
