"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
// Utils
var scope_helpers_1 = require("@amalto/scope-helpers");
var Restricted = /** @class */ (function (_super) {
    __extends(Restricted, _super);
    function Restricted(props) {
        return _super.call(this, props) || this;
    }
    Restricted.prototype.render = function () {
        var _a = this.props, webStorage = _a.webStorage, authorizedActions = _a.authorizedActions, requiredActions = _a.requiredActions, permissions = _a.permissions, featureId = _a.featureId, needsGlobalPermission = _a.needsGlobalPermission, children = _a.children;
        var appInstance = webStorage && webStorage.selectedAppInstance && webStorage.selectedAppInstance.name;
        var scopesTree = webStorage && webStorage.scopesTree;
        if (appInstance && scopesTree) {
            //if actions are specified they will be first used for the display of the children components
            if (authorizedActions && requiredActions) {
                if (scope_helpers_1.canPerformAnyAction(requiredActions, authorizedActions)) {
                    return children;
                }
            }
            else if (permissions && permissions.length) {
                if (scope_helpers_1.hasAnyPermission(webStorage, permissions, needsGlobalPermission)) {
                    return children;
                }
            }
            else if (featureId) {
                if (scope_helpers_1.hasAccessToFeature(webStorage, appInstance, featureId, needsGlobalPermission)) {
                    return children;
                }
            }
        }
        return null;
    };
    return Restricted;
}(React.Component));
exports.default = Restricted;
//# sourceMappingURL=index.js.map