"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var redux_form_1 = require("redux-form");
var classNames = require("classnames");
// Components
var help_1 = require("@amalto/help");
var SelectInput = /** @class */ (function (_super) {
    __extends(SelectInput, _super);
    function SelectInput(props) {
        var _this = _super.call(this, props) || this;
        _this.renderSelect = function (field) {
            var _a = _this.props, label = _a.label, options = _a.options, disabled = _a.disabled, help = _a.help, containerClass = _a.containerClass, inputClass = _a.inputClass, hideEmptyOption = _a.hideEmptyOption, collapseErrorSpace = _a.collapseErrorSpace;
            var input = field.input, meta = field.meta;
            return (React.createElement("div", { className: classNames('form-group', containerClass, {
                    'invalid': meta.touched && !!meta.error
                }) },
                label ? React.createElement("label", null,
                    label,
                    help && React.createElement(help_1.default, { text: help })) : null,
                React.createElement("select", __assign({}, input, { className: classNames('form-control', inputClass), disabled: disabled }),
                    hideEmptyOption ? null : React.createElement("option", { value: "" }),
                    options.map(function (opt, idx) { return React.createElement("option", { key: idx, value: opt.value, disabled: opt.disabled }, opt.label || opt.value); })),
                (meta.touched && !!meta.error) ? React.createElement("p", { className: "validation-error-message" }, meta.error) : (collapseErrorSpace ? null : React.createElement("p", { className: "validation-error-message" }, "\u00A0"))));
        };
        _this.state = {};
        return _this;
    }
    SelectInput.prototype.render = function () {
        var _a = this.props, options = _a.options, name = _a.name, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn, containerClass = _a.containerClass, help = _a.help, label = _a.label, inputClass = _a.inputClass;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn
        };
        return options && options.length ? (React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, { component: this.renderSelect }))) : (React.createElement("div", { className: classNames('form-group', containerClass) },
            label ? React.createElement("label", null,
                label,
                help && React.createElement(help_1.default, { text: help })) : null,
            React.createElement("select", { className: classNames('form-control', inputClass), disabled: true })));
    };
    return SelectInput;
}(React.Component));
exports.default = SelectInput;
//# sourceMappingURL=index.js.map