/// <reference types="react" />
import * as React from 'react';
/**
 * Switch input.
 */
declare module Switch {
    interface Props extends React.Props<Switch> {
        /** Input unique id. */
        id: string;
        /** Input value. */
        value: boolean;
        /** Method triggered when Switch is used. */
        changeHandler: (value: boolean, name?: string) => void;
        /** CSS class of Switch component. */
        cssClass?: string;
        /** Wether the switch input should be align left or not. */
        alignLeft?: boolean;
        /** Input name, if not define id is used instead. */
        name?: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<Switch>;
    }
}
declare class Switch extends React.Component<Switch.Props, any> {
    constructor(props: Switch.Props);
    render(): JSX.Element;
    private handleChange;
}
export default Switch;
