/// <reference types="react" />
/**
 * Created by franckmontaigne on 13/06/16.
 */
import * as React from 'react';
/**
 * Tabs management component allowing you to display custom content.
 */
declare module Tabs {
    interface Props extends React.Props<Tabs> {
        /** Close tab method. */
        closeTab: (tabId: string) => void;
        /** Select tab method. */
        openedTab: (tabId: string) => void;
        /** Allow horizontal scrolling on tab list. */
        allowHorizontalScrolling?: boolean;
        /** Tab list. */
        tabs: JSX.Element[];
        /** Current tab selected. */
        selectedTabId: string;
        /** Array of all the tab in edit state. Tab title will be in italic. */
        editedTabIds?: string[];
        /** Tabs component CSS style. */
        tabWrapperStyle?: React.CSSProperties;
        /** Common tab CSS style for all Tab. */
        tabLinkStyle?: React.CSSProperties;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<Tabs>;
    }
    interface State {
    }
}
declare class Tabs extends React.Component<Tabs.Props, Tabs.State> {
    constructor(props: Tabs.Props);
    render(): JSX.Element;
    private closeTab;
    private openTab;
}
export default Tabs;
