"use strict";
/**
 * Created by franckmontaigne on 13/06/16.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
var PerfectScrollbar = require("react-perfect-scrollbar");
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs(props) {
        var _this = _super.call(this, props) || this;
        _this.closeTab = function (tabId) {
            _this.props.closeTab(tabId);
        };
        _this.openTab = function (tabId) {
            _this.props.openedTab(tabId);
        };
        return _this;
    }
    Tabs.prototype.render = function () {
        var _this = this;
        var _a = this.props, tabs = _a.tabs, closeTab = _a.closeTab, tabWrapperStyle = _a.tabWrapperStyle, tabLinkStyle = _a.tabLinkStyle, selectedTabId = _a.selectedTabId, editedTabIds = _a.editedTabIds;
        var tabsContent = tabs.map(function (tab) {
            return (React.createElement("li", { className: classNames({
                    'closable': tab.props.closable,
                    'active': tab.props.id === selectedTabId
                }), style: tabLinkStyle, key: tab.props.id },
                React.createElement("a", { href: "#", id: tab.props.id + "_tab_anchor", onClick: function (e) { e.preventDefault(); _this.openTab(tab.props.id); }, title: tab.props.title, className: classNames((_a = {
                            'italic black-color-important': editedTabIds && editedTabIds.indexOf(tab.props.id) >= 0
                        },
                        _a[tab.props.tabLinkUniqueClass] = !!tab.props.tabLinkUniqueClass,
                        _a)), style: tab.props.tabLinkUniqueStyle },
                    tab.props.iconClass ? React.createElement("i", { className: classNames(tab.props.iconClass + " right-spaced") }) : null,
                    tab.props.title),
                tab.props.closable ? React.createElement("button", { className: "close", onClick: function (e) { return _this.closeTab(tab.props.id); } }, "\u00D7") : null));
            var _a;
        });
        return tabs.length ? (React.createElement("div", { className: "tab-wrapper", style: tabWrapperStyle },
            this.props.allowHorizontalScrolling ? (React.createElement(PerfectScrollbar, { option: { useBothWheelAxes: true, suppressScrollY: true } },
                React.createElement("ul", { className: "nav nav-tabs" }, tabsContent))) : React.createElement("ul", { className: "nav nav-tabs" }, tabsContent),
            React.createElement("div", { className: "tab-content" }, tabs.map(function (tab) {
                return (React.createElement("div", { key: tab.props.id, id: tab.props.id, className: classNames('tab-pane', tab.props.tabClassNames, {
                        'active': tab.props.id === selectedTabId
                    }), style: tab.props.tabStyle }, tab.props.children));
            })))) : null;
    };
    return Tabs;
}(React.Component));
exports.default = Tabs;
//# sourceMappingURL=index.js.map