"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var uuid = require("uuid");
var redux_form_1 = require("redux-form");
// Components
var help_1 = require("@amalto/help");
// Utils
var classNames = require("classnames");
var TextInput = /** @class */ (function (_super) {
    __extends(TextInput, _super);
    function TextInput(props) {
        var _this = _super.call(this, props) || this;
        _this.renderText = function (field) {
            var _a = _this.props, label = _a.label, disabled = _a.disabled, autofocus = _a.autofocus, help = _a.help, containerClass = _a.containerClass, inputClass = _a.inputClass, type = _a.type, randomGenerator = _a.randomGenerator, placeholder = _a.placeholder, collapseErrorSpace = _a.collapseErrorSpace;
            var input = field.input, meta = field.meta;
            return (React.createElement("div", { className: classNames('form-group', containerClass, {
                    'invalid': meta.touched && !!meta.error
                }) },
                label ? React.createElement("label", null,
                    label,
                    help && React.createElement(help_1.default, { text: help })) : null,
                React.createElement("input", __assign({}, input, { type: type || 'text', placeholder: placeholder, disabled: disabled, autoFocus: autofocus, className: classNames('form-control input-block', inputClass, {
                        'btn-prefix': randomGenerator
                    }) })),
                randomGenerator ? (React.createElement("button", { type: "button", className: "btn btn-info input-suffix", onClick: function (e) { return _this.generateClientSecret(field); } },
                    React.createElement("span", { className: "fas fa-random" }))) : null,
                (meta.touched && !!meta.error) ? React.createElement("p", { className: "validation-error-message" }, meta.error) : (collapseErrorSpace ? null : React.createElement("p", { className: "validation-error-message" }, "\u00A0"))));
        };
        _this.generateClientSecret = function (field) {
            field.input.onChange(uuid.v1(), undefined, undefined);
        };
        _this.state = {};
        return _this;
    }
    TextInput.prototype.render = function () {
        var _a = this.props, name = _a.name, label = _a.label, format = _a.format, normalize = _a.normalize, parse = _a.parse, validate = _a.validate, warn = _a.warn;
        var baseFieldProps = {
            name: name,
            format: format,
            normalize: normalize,
            parse: parse,
            validate: validate,
            warn: warn
        };
        return React.createElement(redux_form_1.Field, __assign({}, baseFieldProps, { component: this.renderText }));
    };
    return TextInput;
}(React.Component));
exports.default = TextInput;
//# sourceMappingURL=index.js.map