"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Components
var spinner_1 = require("@amalto/spinner");
var TogglePanel = /** @class */ (function (_super) {
    __extends(TogglePanel, _super);
    function TogglePanel(props) {
        var _this = _super.call(this, props) || this;
        _this.togglePanelContent = function (event) {
            if (_this.props.togglable !== false) {
                _this.setState({
                    opened: !_this.state.opened
                }, function () {
                    if (_this.props.toggleCallback) {
                        _this.props.toggleCallback(_this.state.opened);
                    }
                });
            }
        };
        _this.state = {
            opened: _this.props.defaultOpened
        };
        return _this;
    }
    TogglePanel.prototype.render = function () {
        var titleSpinner = this.props.showSpinner ? (React.createElement("div", { className: "spinner-container" },
            React.createElement(spinner_1.default, null))) : null;
        var lCustomControls = this.props.leftCustomControls ? (React.createElement("div", { className: "panel-heading-controls" }, this.props.leftCustomControls)) : null;
        var rCustomControls = this.props.rightCustomControls ? (React.createElement("div", { className: "panel-heading-controls", style: { right: 0 } }, this.props.rightCustomControls)) : null;
        var cancelBtn = (this.props.cancelBtn && this.props.cancelBtn.label && this.props.cancelBtn.action) ? (React.createElement("button", { type: "button", className: classNames('btn', this.props.cancelBtn.cssClass, {
                'btn-font btn-trans': !this.props.cancelBtn.cssClass
            }), onClick: this.props.cancelBtn.action }, this.props.cancelBtn.label)) : null;
        var submitBtn = (this.props.submitBtn && this.props.submitBtn.label && this.props.submitBtn.action) ? (React.createElement("button", { type: "button", className: classNames('btn pull-right', this.props.submitBtn.cssClass, {
                'btn-success': !this.props.submitBtn.cssClass
            }), onClick: this.props.submitBtn.action }, this.props.submitBtn.label)) : null;
        var panelFooter = (cancelBtn || submitBtn) ? (React.createElement("div", { className: "panel-footer" },
            cancelBtn,
            submitBtn)) : null;
        return (React.createElement("div", { className: "panel panel-default", style: this.props.customStyle },
            React.createElement("div", { className: classNames('panel-heading', {
                    'click-pointer': this.props.togglable !== false,
                    'hidden': !!this.props.hideTitle
                }), onClick: this.togglePanelContent },
                React.createElement("h3", { className: classNames('panel-title', {
                        'has-spinner': this.props.showSpinner
                    }) }, this.props.panelTitle),
                titleSpinner,
                lCustomControls,
                rCustomControls,
                React.createElement("div", { className: classNames('actions', { 'hidden': this.props.togglable === false }) },
                    React.createElement("span", { className: classNames('fas', {
                            'fa-chevron-down': !this.state.opened,
                            'fa-chevron-up': this.state.opened
                        }) }))),
            React.createElement("div", { className: classNames('panel-body', {
                    'hidden': !this.state.opened
                }) }, this.props.children),
            panelFooter));
    };
    TogglePanel.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.defaultOpened !== nextProps.defaultOpened) {
            this.setState({
                opened: nextProps.defaultOpened
            });
        }
    };
    return TogglePanel;
}(React.Component));
exports.default = TogglePanel;
//# sourceMappingURL=index.js.map