/// <reference types="react" />
/// <reference types="jquery" />
import * as React from 'react';
import 'typeahead.js';
/**
 * Typeahead input displaying a filtered dropdown list from your input and your collection.
 */
declare module TypeaheadInput {
    interface Props extends React.Props<TypeaheadInput> {
        /** Div id. */
        id: string;
        /** Collection of item to be display inside the dropdown list. */
        collection: any[];
        /** Search remotely from server. More details on [RemoteConfig](http://localhost:6060/#remoteconfig). */
        remote?: RemoteConfig;
        /** Input's value. */
        value?: any;
        /** Input's onchange event. */
        handleInputChange: (value: any) => void;
        /** Manage input value to be displayed. */
        display?: (value: any) => string;
        /** Manage the dropdown list of choices when input value is updated by user. */
        datumTokenizer?: (datum: any) => string[];
        /** Input's placeholder. */
        placeholder?: string;
        /** Hide props from documentation */
        /** @ignore */
        children?: React.ReactNode;
        /** @ignore */
        key?: React.ReactText;
        /** @ignore */
        ref?: React.Ref<TypeaheadInput>;
    }
    interface RemoteConfig {
        url: string;
        prepare?: (query: string, settings: JQueryAjaxSettings) => JQueryAjaxSettings;
        wildcard?: string;
        rateLimitby?: string;
        rateLimitWait?: number;
        transform?: (response: any) => any;
    }
}
declare class TypeaheadInput extends React.Component<TypeaheadInput.Props, any> {
    constructor(props: TypeaheadInput.Props);
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: TypeaheadInput.Props): void;
    private handleInputBlur;
}
export default TypeaheadInput;
