"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
require("typeahead.js");
var TypeaheadInput = /** @class */ (function (_super) {
    __extends(TypeaheadInput, _super);
    function TypeaheadInput(props) {
        var _this = _super.call(this, props) || this;
        _this.handleInputBlur = function (event) {
            var _a = _this.props, display = _a.display, value = _a.value, handleInputChange = _a.handleInputChange;
            if (!event.target.value) {
                handleInputChange(null);
            }
            else {
                $('.typeahead').typeahead('val', display ? display(value) : value);
            }
        };
        return _this;
    }
    TypeaheadInput.prototype.render = function () {
        return (React.createElement("div", { id: this.props.id },
            React.createElement("input", { className: "form-control typeahead", type: "text", onBlur: this.handleInputBlur, name: this.props.id, placeholder: this.props.placeholder })));
    };
    TypeaheadInput.prototype.componentDidMount = function () {
        var _a = this.props, collection = _a.collection, remote = _a.remote, id = _a.id, value = _a.value, handleInputChange = _a.handleInputChange, display = _a.display, datumTokenizer = _a.datumTokenizer;
        var _collection = new Bloodhound({
            initialize: false,
            datumTokenizer: datumTokenizer || Bloodhound.tokenizers.whitespace,
            queryTokenizer: Bloodhound.tokenizers.whitespace,
            local: collection,
            remote: remote
        });
        _collection.initialize();
        $('.typeahead').typeahead({
            hint: true,
            highlight: true,
            minLength: 1
        }, {
            name: id,
            source: _collection,
            limit: Infinity,
            display: display
        });
        $('.typeahead').typeahead('val', display ? display(value) : value);
        $('.typeahead').bind('typeahead:select', (function (event, suggestion) {
            handleInputChange(suggestion);
        }));
    };
    TypeaheadInput.prototype.componentWillUnmount = function () {
        $('.typeahead').typeahead('destroy');
    };
    TypeaheadInput.prototype.componentDidUpdate = function (prevProps) {
        var _a = this.props, display = _a.display, value = _a.value;
        if (prevProps.value !== value) {
            $('.typeahead').typeahead('val', display ? display(value) : value);
        }
    };
    return TypeaheadInput;
}(React.Component));
exports.default = TypeaheadInput;
//# sourceMappingURL=index.js.map