"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
// Modules
var React = require("react");
var classNames = require("classnames");
// Components
var help_1 = require("@amalto/help");
var ValidatedInput = /** @class */ (function (_super) {
    __extends(ValidatedInput, _super);
    function ValidatedInput(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var inputValue = JSON.parse(JSON.stringify(event.target.value));
            _this.validateField(inputValue, _this.props);
        };
        _this.validateField = function (value, props) {
            var emptyButMandatory = !value && !!props.mandatory;
            var noMatchRegex = props.regex ? !props.regex.test(value) : false;
            var invalid = props.validate ? !props.validate(value) : false;
            if (!props.disabled) {
                _this.setState({
                    invalidInput: emptyButMandatory || noMatchRegex || invalid
                }, function () {
                    props.handleFieldChange(value, props.name, _this.state.invalidInput);
                });
            }
        };
        _this.state = {
            invalidInput: false
        };
        return _this;
    }
    ValidatedInput.prototype.render = function () {
        var _a = this.props, name = _a.name, label = _a.label, help = _a.help, value = _a.value, disabled = _a.disabled, choices = _a.choices, placeholder = _a.placeholder, autoComplete = _a.autoComplete, mandatory = _a.mandatory, errorMessage = _a.errorMessage, containerClass = _a.containerClass, inputClass = _a.inputClass;
        var inputDisplay = this.props.choices ? (React.createElement("select", { className: classNames('form-control', inputClass), name: name, value: value, onChange: this.handleChange, disabled: disabled }, choices.map(function (choice, idx) {
            return React.createElement("option", { key: idx, value: choice.value }, choice.label || choice.value);
        }))) : (React.createElement("input", { type: "text", className: classNames('form-control', inputClass), name: name, value: value, onChange: this.handleChange, disabled: disabled, placeholder: placeholder, autoComplete: autoComplete }));
        return (React.createElement("div", { className: classNames('form-group', containerClass, {
                'invalid': this.state.invalidInput,
                'mandatory': mandatory
            }) },
            label ? React.createElement("label", null,
                label,
                help && React.createElement(help_1.default, { text: help })) : null,
            inputDisplay,
            this.state.invalidInput && errorMessage ? React.createElement("p", { className: "validation-error-message" }, errorMessage) : null));
    };
    ValidatedInput.prototype.componentDidMount = function () {
        if (this.props.validateOnLoad) {
            this.validateField(this.props.value, this.props);
        }
    };
    ValidatedInput.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.formSubmitted !== nextProps.formSubmitted && nextProps.formSubmitted === true) {
            this.validateField(nextProps.value, nextProps);
        }
    };
    return ValidatedInput;
}(React.Component));
exports.default = ValidatedInput;
//# sourceMappingURL=index.js.map